;----------------------------------------Bot Functions


;--------------------Waypoint in Nhe finden
;X/Y in Tiles
Function bot_findwp(x,y)
	Local lowestdist=99999999
	Local lowestwp=-1
	Local dist
	For pf_wp.pf_wp=Each pf_wp
		dist=Sqr((x-pf_wp\x)^2+(y-pf_wp\y)^2)
		If dist<lowestdist Then
			;Direkte Verbindung?
			If bot_directway((x*32)+16,(y*32)+16,(pf_wp\x*32)+16,(pf_wp\y*32)+16)
				lowestwp=pf_wp\id
				lowestdist=dist
				If dist<2 Then Return lowestwp
			EndIf
		EndIf
	Next
	Return lowestwp
End Function


;--------------------Waypoint Pos
Function bot_wp_pos(id)
	For pf_wp.pf_wp=Each pf_wp
		If pf_wp\id=id Then
			x=pf_wp\x
			y=pf_wp\y
			Return 1
		EndIf
	Next
End Function


;--------------------Path (Pfad bestimmen mit Pathfinding)
Function bot_path(id,startwp,endwp)
	Local reached,limit,used,level
	;startwp <> endwp?
	If startwp=endwp Then
		Return 0
	EndIf
	;startwp und endwp <> -1?
	If startwp=-1 Then Return 0
	If endwp=-1 Then Return 0
	;Alte Nodes lschen
	For pf_node.pf_node=Each pf_node
		Delete pf_node
	Next
	;Root Node Anlegen
	pf_node.pf_node=New pf_node
	pf_node\parent=-1
	pf_node\wp=startwp
	pf_node\cost=0
	pf_node\totalcost=0
	pf_node\level=0
	limit=MilliSecs()
	Local newnodec
	
	;-----Wege suchen
	While Not reached
		;Level der Nodes erhhen
		level=level+1
		
		;NewNode Count
		newnodec=0
		
		;Nodes dieses Levels durchgehen		
		For pf_node.pf_node=Each pf_node
			If pf_node\level=level-1 Then
				For pf_link.pf_link=Each pf_link
				
					;WAYPOINT 1
					If pf_link\wp1=pf_node\wp Then
						used=0
						For pf_node2.pf_node=Each pf_node
							If pf_node2\wp=pf_link\wp2
								used=1
								Exit
							EndIf
						Next
						If Not used Then
							pf_node2.pf_node=New pf_node
							pf_node2\parent=pf_node\wp
							pf_node2\wp=pf_link\wp2
							pf_node2\cost=pf_link\cost
							pf_node2\totalcost=pf_node\totalcost+pf_link\cost
							pf_node2\level=level
							If pf_node2\wp=endwp Then reached=1
							newnodec=newnodec+1
						EndIf
					;WAYPOINT 2	
					ElseIf pf_link\wp2=pf_node\wp
						used=0
						For pf_node2.pf_node=Each pf_node
							If pf_node2\wp=pf_link\wp1
								used=1
								Exit
							EndIf
						Next
						If Not used Then
							pf_node2.pf_node=New pf_node
							pf_node2\parent=pf_node\wp
							pf_node2\wp=pf_link\wp1
							pf_node2\cost=pf_link\cost
							pf_node2\totalcost=pf_node\totalcost+pf_link\cost
							pf_node2\level=level
							If pf_node2\wp=endwp Then reached=1
							newnodec=newnodec+1
						EndIf
					EndIf
					
					
				Next
			EndIf
		Next
		
		;No New Node
		If newnodec=0 Then
			If op_debug Then con_add("Error: Bot Pathfinding - Unable to Find Path",0,0)
			Return 0
		EndIf
		
		;Timeout
		If MilliSecs()-limit>10 Then
			If op_debug Then con_add("Timeout Error: Bot Pathfinding - Create Nodes",0,0)
			Return 0
		EndIf
	Wend
	
	;Krzesten Weg von Ziel zu Start zurckverfolgen und an Bot bergeben
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	;Im Spieler cached Nodes lschen
	For i=0 To 10
		player\bot_mm_pfn[i]=-1
	Next
	;Current Node auf 0 setzen
	player\bot_mm_cn=0
	
	;Node 0 auf Startwaypoint setzen
	player\bot_mm_pfn[0]=startwp
	reached=0
	parentwp=endwp
	limit=MilliSecs()
	
	;An den Nodes vom Ziel Rckwrts zum Anfang hangeln und die ersten 10 Nodes cachen!
	While Not reached
		For pf_node.pf_node=Each pf_node
			;Parent Node dieser Node?
			If pf_node\wp=parentwp Then
				parentwp=pf_node\parent
				;Waypoint an Bot bergeben? (Nur die ersten 10, da Bot nur 11 cachen kann!)
				If pf_node\level<=10 Then
					player\bot_mm_pfn[pf_node\level]=pf_node\wp
				EndIf
				
				;<<<DEBUG>>>
				If op_debug_bots=1
					For pf_wp.pf_wp=Each pf_wp
						If pf_wp\id=parentwp Then
							x=e_add_sprite_wave(pf_wp\x*32+16,pf_wp\y*32+16,32,1)
							EntityColor x,255,255,0
							Exit
						EndIf
					Next
				EndIf
				;<<<DEBUG>>>
				
				;Abbrechen wenn Startwaypoint erreicht ist
				If parentwp=startwp Then reached=1
				Exit
			EndIf
		Next
		;Timeout
		If MilliSecs()-limit>5 Then
			con_add("Timeout Error: Bot Pathfinding - Retracing Nodes",0,0)
			Return 0
		EndIf
	Wend
	
	;Ok
	Return reached
End Function


;--------------------Mate Sneak (Gegner in Nhe die Schleichen?)
Function bot_sneak(id,range=180)
	Local ph=0,sneak=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return -1
	If Not player\h Then Return -1
	
	;Krzlich getroffen? -> nicht schleichen!
	If ms-player\bot_enemy_lasthit<4500 Then Return 0
	
	;Schleichende Teammates in der nhe? -> schleichen!
	For player2.player=Each player
		If player2\team=player\team Then
			If player2\legs_lastspeed=95
				If Abs(player2\x-player\x)<=range Then
					If Abs(player2\y-player\y)<=range Then
						sneak=1
					EndIf
				EndIf
			EndIf
		EndIf
	Next
	
	Return sneak
End Function

;--------------------Enemey Scan (Gegner suchen)
Function bot_enemy_scan(id)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return -1
	If Not player\h Then Return -1
	
	;Cachen
	Local x,y,team
	Local dx,dy
	Local target
	Local lowestdist=50000
	Local lowestid=-1
	x=player\x
	y=player\y
	team=player\team
	
	;Scan
	For player2.player = Each player
		If player2\health>0 Then
			If player2\team<>team Then
				dx=Abs(player2\x-x)
				dy=Abs(player2\y-y)
				If (dx+dy)<lowestdist Then
					lowestdist=(dx+dy)
					lowestid=player2\id
				EndIf
			EndIf
		EndIf
	Next
	
	;Nhesten Spieler zurckgeben
	Return lowestid
End Function

;--------------------Enemy Aim (Gegner anvisieren)
Function bot_enemy_aim(id,dev=0)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	;Gegner suchen und zu ihm drehen (=anvisieren)
	For player2.player = Each player
		If player2\id=player\bot_enemy_id
			If Abs(player\x-player2\x)<=(10*32) And Abs(player\y-player2\y)<=(7*32) Then		
				player\bot_rotate_dir=ATan2(player2\x+16+Rand(-dev,dev)-(player\x+16),(player\y+16)-(player2\y+16)+Rand(-dev,dev))
				Return 1
			Else
				Return 0
			EndIf
		EndIf
	Next
	Return 0
End Function

;--------------------Enemy Freeline (Freie Schussbahn?)
Function bot_enemy_freeline(pl1,pl2)
	Local ph=0
	For player.player=Each player
		If player\id=pl1 Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	Local dir
	dir=player\dir
	Local sx#=player\x+16
	Local sy#=player\y+16
	Local xo#=Sin(dir)*6
	Local yo#=-Cos(dir)*6
	Local maxdis,stx,sty
	Local enemyhit
	
	For maxdis=0 To weapon_range(player\sweapon[player\slot])
		;Bewegen
		sx#=sx#+xo#
		sy#=sy#+yo#
		
		;<<<DEBUG>>>
		If op_debug_bots Then
			e_add_par2d($00FF00,Rand(200,600),sx#,sy#,0,0)
		EndIf
		;<<<DEBUG>>>
		
		stx=Int((sx#-16)/32)
		sty=Int((sy#-16)/32)
				
		;Bei Maprand abbrechen
		If stx<0 Then Exit
		If sty<0 Then Exit
		If stx>map_xsize Exit
		If sty>map_ysize Exit
				
		;Bei Wnden abbrechen
		If map(stx,sty,3)=1 Then Exit
		If map(stx,sty,3)=3 Then Exit
		
		;Spieler getroffen?
		For player2.player=Each player
			If player2\id=pl2 Then
				If player2\health>0 Then
					If player2\team=1 Or player2\team=2 Then
						If RectsOverlap(sx-2,sy-2,4,4,player2\x,player2\y,32,32) Then
							;Bei Teammate Canceln!
							If player2\team=player\team Then
								Return 0
							Else
							;Bei Gegner Enemyhit auf 1, vorrausgesetzt er ist auf dem Screen des Bots
								If Abs(player\x-player2\x)<=(10*32) And Abs(player\y-player2\y)<=(7*32) Then
									enemyhit=1
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		Next
		
	Next
	
	;Ergebnis zurckliefern
	Return enemyhit
End Function



;--------------------Items suchen
Function bot_item_scan(id)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	If player\vip Then Return 0
	
	Local px=player\x/32
	Local py=player\y/32
	Local damage#[1]
	Local ammo[1]
	Local range[1]
	Local gogetit=0
	
	For item.item=Each item
		If Abs(item\x-px)<5 Then
			If Abs(item\y-py)<5 Then
				
				;Schusswaffe?
				If item\typ<50 Then
				
					;Wert des Items bestimmen
					damage[0]=weapon_damage(item\typ)*(286/weapon_freq(item\typ))
					ammo[0]=item\ammo+item\ammoin
					range[0]=weapon_range(item\typ)
					
					;Wert der eigenen Waffe bestimmen
					If item\typ<10 Then
						If player\sweapon[1]<>0 Then
							damage[1]=weapon_damage(player\sweapon[1])*(286/weapon_freq(player\sweapon[1]))
							ammo[1]=player\sammo[1]+player\sammoin[1]
							range[1]=weapon_range(player\sweapon[1])
						EndIf
					ElseIf item\typ
						If player\sweapon[0]<>0 Then
							damage[1]=weapon_damage(player\sweapon[0])*(286/weapon_freq(player\sweapon[0]))
							ammo[1]=player\sammo[0]+player\sammoin[0]
							range[1]=weapon_range(player\sweapon[0])
						EndIf
					EndIf
					
					;Holen gehen wenn Waffe "besser" ist
					If (damage[0]*50+ammo[0]*10+range[0])-(damage[1]*50+ammo[1]*10+range[1])>590 Then
						;Wenn mininmal 10 Schuss drin sind
						If ammo[0]>9 Then
							;Schnellfeuerwaffe mit genug Munition oder starke Waffe
							If ammo[0]>29 Or damage[0]>60 Then
								gogetit=1
							EndIf
						EndIf
					EndIf
					;Wenn eigene Waffe leer ist auf jeden fall nehmen ;)
					If ammo[1]=0 And ammo[0]>0 Then
						gogetit=1
					EndIf
					
				
				;Anderes Zeug
				Else
				
					;Bombe
					If player\team=1 And item\typ=55 Then gogetit=1
					
					;Defuse
					If (player\team=2 And item\typ=56) And player\sweapon[8]=0 Then gogetit=1
				
				EndIf
				
				
				;Holen gehen
				If gogetit Then
					;Drop?
					If item\typ<50 Then
						;Drop Primary
						If item\typ<10 Then
							player_drop(player\id,1,player\sweapon[1],player\sammo[1],player\sammoin[1],(Int(player\x)+16)/32,(Int(player\y)+16)/32,1)
						;Drop Secondary
						Else
							player_drop(player\id,0,player\sweapon[0],player\sammo[0],player\sammoin[0],(Int(player\x)+16)/32,(Int(player\y)+16)/32,1)
						EndIf
						player_bestweapon(player\id)
					EndIf
					;Holen!
					player\bot_obj[0]=30
					player\bot_obj[1]=item\x
					player\bot_obj[2]=item\y
					Return 1
				EndIf
				
			EndIf
		EndIf
	Next
	Return 0
End Function


;--------------------Sagen
Function bot_say(id,txt$)
	For player.player=Each player
		If player\id=id Then
			If ms-player\bot_say>5000 Then
				player_say(id,txt$)
				player\bot_say=ms
			EndIf
			Return 1
		EndIf
	Next
	Return 0
End Function




;--------------------Einkaufen
Function bot_buy(id)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	Local mon=player\money
	Local bought
	Select player\bot_buy_step
		;1 - Primary Weapon
		Case 1
			;Normal
			If op_bot_mode=1
				;Item zum aufsammeln in der Nhe? Wenn ja: Kaufen der Waffen berspringen
				If bot_item_scan(player\id) Then
					player\bot_buy_timer=ms+Rand(300,700)
					player\bot_buy_step=3
				;Sparen wenn Geld niedrig ist
				ElseIf mon<3000 And Rand(3)=1 Then
					player\bot_buy_step=0
				Else
					;>1500
					If mon>1500 And mon<2500 Then
						If Rand(2)=1 Then
							Select Rand(1)
								Case 0 player_buy(id, 21)
								Case 1 player_buy(id, 23)
							End Select
						EndIf
					;>2500
					ElseIf mon>=2500 And mon<3500 Then
						Select Rand(3)
							Case 0 player_buy(id, 10)
							Case 1 player_buy(id, 20)
							Case 2 player_buy(id, 22)
							Case 3 player_buy(id, 24)
						End Select
					;Rest
					Else
						Select Rand(9)
							Case 0 player_buy(id, 11)
							Case 1 player_buy(id, 30)
							Case 2 player_buy(id, 31)
							Case 3 player_buy(id, 32)
							Case 4 player_buy(id, 33)
							Case 5 player_buy(id, 34)
							Case 6 player_buy(id, 35)
							Case 7 player_buy(id, 36)
							Case 8 player_buy(id, 37)
							Case 9 player_buy(id, 40)
						End Select
					EndIf
					player\bot_buy_timer=ms+Rand(300,700)
					player\bot_buy_step=2
				EndIf
			;Special Weapon Mode
			Else
				Select op_bot_mode
					;2 - Knifes only
					Case 2
					;3 - Pistols only
					Case 3
					;4 - Shotguns only
					Case 4
						player_buy(id, Rand(10,11))
					;5 - SMGs only
					Case 5
						player_buy(id, Rand(20,24))
					;6 - Rifles only
					Case 6
						player_buy(id, Rand(30,33))
					;7 - Sniper-Rifles only
					Case 7
						player_buy(id, Rand(34,37))
					;8 - MGs only
						player_buy(id, 40)
					Case 8	
				End Select
				player\bot_buy_timer=ms+Rand(300,700)
				player\bot_buy_step=2
			EndIf
		;2 - Secondary Weapon
		Case 2
			If Rand(5)=1 Then
				player_buy(id, Rand(1,6))
				player\bot_buy_timer=ms+Rand(150,300)
				player\bot_buy_step=3
			Else
				player\bot_buy_step=3
			EndIf
		;3 - Ammo
		Case 3
			bought=0
			bought=bought+player_buy(id, 61)
			bought=bought+player_buy(id, 62)
			player\bot_buy_timer=ms+Rand(100,200)
			If bought=0 Then
				player\bot_buy_step=5
			Else
				player\bot_buy_step=3
			EndIf
		;5 - Equipment
		Case 5
			If player\money>=200 Then
				player_buy(id, 56)					;Defuse Kit
			EndIf
			If player\money>=1000 Then
				Select Rand(1)
					Case 0 player_buy(id, 57)		;Kevlar
					Case 1 player_buy(id, 58)		;Kevlar+Helm
				End Select
			EndIf
			player_bestweapon(id)
			player\bot_buy_step=0
	End Select
End Function

;--------------------Absolutes Ziel suchen
Function bot_findtarget(id)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	Local startwp=-1
	Local endwp=-1
	Local unusedhostages
	
	;Startwegpunkt definieren
	startwp=bot_findwp((player\x+16)/32,(player\y+16)/32)
	;Wenn kein Startwegpunkt gefunden wird den Bot zufllig herumlaufen lassen ;)
	If startwp=-1 Then
		If op_debug_bots Then bot_say(player\id,"Doh! Where to go? Damn walls!")
		player\bot_obj[0]=90
		player\bot_obj[1]=Rand(0,3)
		player\bot_obj[2]=ms
		Return 0
	EndIf
	
	;Zielwegpunkt
	
		Select map_gametype
		
			;0 - Deathmatch, zufllig
			Case 0
				;Zufllig
				While endwp=-1
					For pf_wp.pf_wp=Each pf_wp
						If Rand(100)=1 Then
							endwp=pf_wp\id
							player\bot_obj[0]=1
							player\bot_obj[1]=pf_wp\x
							player\bot_obj[2]=pf_wp\y
							Exit
						EndIf
					Next
				Wend
			
			;1 - AS
			Case 1
				;Zum Escapepoint
				If player\vip=1 Then
					While endwp=-1
						For entity.entity=Each entity
							If entity\typ=6 Then
								If Rand(20)=1 Then
									endwp=bot_findwp(entity\x,entity\y)
									player\bot_obj[0]=1
									player\bot_obj[1]=entity\x
									player\bot_obj[2]=entity\y
								EndIf
							EndIf
						Next
					Wend
				;Zufllig
				Else
					While endwp=-1
						For pf_wp.pf_wp=Each pf_wp
							If Rand(100)=1 Then
								endwp=pf_wp\id
								player\bot_obj[0]=1
								player\bot_obj[1]=pf_wp\x
								player\bot_obj[2]=pf_wp\y
								Exit
							EndIf
						Next
					Wend
				EndIf
				
			;2 - CS
			Case 2
				;Hostage
				If player\team=2 Then
					unusedhostages=0
					For hostage.hostage=Each hostage
						If hostage\followid=-1 Then
							unusedhostages=unusedhostages+1
						EndIf
					Next
					;Zu Geisel!
					If unusedhostages>0 Then
						While endwp=-1
							For hostage.hostage=Each hostage
								If hostage\followid=-1 Then
									If Rand(unusedhostages+1)=1 Then
										endwp=bot_findwp((hostage\x/32),(hostage\y/32))
										player\bot_obj[0]=1
										player\bot_obj[1]=(hostage\x/32)
										player\bot_obj[2]=(hostage\y/32)
									EndIf
								EndIf
							Next
						Wend
					;Zu Rescuepoint
					Else
						While endwp=-1
							For entity.entity=Each entity
								If entity\typ=4 Then
									If Rand(3)=1 Then
										endwp=bot_findwp(entity\x,entity\y)
										player\bot_obj[0]=1
										player\bot_obj[1]=entity\x
										player\bot_obj[2]=entity\y
									EndIf
								EndIf
							Next
						Wend
					EndIf
				;Zufllig
				Else
					While endwp=-1
						For pf_wp.pf_wp=Each pf_wp
							If Rand(100)=1 Then
								endwp=pf_wp\id
								player\bot_obj[0]=1
								player\bot_obj[1]=pf_wp\x
								player\bot_obj[2]=pf_wp\y
								Exit
							EndIf
						Next
					Wend
				EndIf
			
			;3 - DE
			Case 3
				;Zum Bombspot
				If player\sweapon[7]=55 Then
					While endwp=-1
						For entity.entity=Each entity
							If entity\typ=5 Then
								If Rand(5)=1 Then
									endwp=bot_findwp(entity\x,entity\y)
									player\bot_obj[0]=1
									player\bot_obj[1]=entity\x
									player\bot_obj[2]=entity\y
								EndIf
							EndIf
						Next
					Wend
				;Zur Bombe
				ElseIf player\team=2 And e_sv_bombtimer<>0 Then
					While endwp=-1
						For item.item=Each item
							If item\typ=100 Then
								endwp=bot_findwp(item\x,item\y)
								player\bot_obj[0]=1
								player\bot_obj[1]=item\x
								player\bot_obj[2]=item\y
								Exit
							EndIf
						Next 
					Wend 
				;Zufllig
				Else
					While endwp=-1
						For pf_wp.pf_wp=Each pf_wp
							If Rand(100)=1 Then
								endwp=pf_wp\id
								player\bot_obj[0]=1
								player\bot_obj[1]=pf_wp\x
								player\bot_obj[2]=pf_wp\y
								Exit
							EndIf
						Next
					Wend
				EndIf
				
		End Select
	
	;Pfad finden
	If player\bot_obj[0]=1 Then
		bot_path(id,startwp,endwp)
	EndIf
	player\bot_mm_tx=-1
	player\bot_mm_ty=-1
End Function


;--------------------Zum Ziel laufen
Function bot_move_target(id,silent=0)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	;Nchstes Sub-Ziel einlesen falls Ziel unklar ist
	If player\bot_mm_tx=-1 Or player\bot_mm_ty=-1 Then
	
		;Bewegung zu einem Waypoint aus dem Cache?
		Local movewp=0
		
		;Nchstes Ziel auslesen aus Waypoint Cache
		If player\bot_mm_cn<11 Then
			If player\bot_mm_pfn[player\bot_mm_cn]>-1 Then
				For pf_wp.pf_wp=Each pf_wp
					If pf_wp\id=player\bot_mm_pfn[player\bot_mm_cn] Then
						player\bot_mm_tx=pf_wp\x
						player\bot_mm_ty=pf_wp\y
						player\bot_mm_cn=player\bot_mm_cn+1
						;Zu Ziel drehen
						player\bot_rotate_dir=ATan2((player\bot_mm_tx*32)-(player\x),(player\y)-(player\bot_mm_ty*32))
						;Ok
						movewp=1
						Exit
					EndIf
				Next
			EndIf
		EndIf
		
		;Kein Waypoint mehr im Cache?
		If movewp=0 Then
			;Ziel auf direktem Weg erreichen?
			If bot_freeway(player\id,player\bot_obj[1],player\bot_obj[2]) Then
				player\bot_mm_tx=player\bot_obj[1]
				player\bot_mm_ty=player\bot_obj[2]
			;Oder neue Waypoint Route ermitteln
			Else
				Local startwp=bot_findwp((player\x+16)/32,(player\y+16)/32)
				Local endwp=bot_findwp(player\bot_obj[1],player\bot_obj[2])
				bot_path(id,startwp,endwp)
				Return 0
			EndIf
		EndIf
		
	EndIf

	;Cachen
	Local px,py,tx,ty,td,reached
	px=player\x
	py=player\y
	tx=player\bot_mm_tx*32
	ty=player\bot_mm_ty*32

	;Kein Ziel definiert? -> Neue Aktion suchen
	If tx=-32 Or ty=-32 Then
		player\bot_obj[0]=0
		Return 0
	EndIf
	
	;Bewegen (X)
	If Abs(px-tx)>2.1*spfak Then
		If px<tx Then
			player_move(id,90,2.0*spfak#,silent)
		Else
			player_move(id,-90,2.0*spfak#,silent)
		EndIf
	Else
		player\x=tx
		reached=1
	EndIf
	
	;Bewegen (Y)
	If Abs(py-ty)>2.1*spfak Then
		If py<ty Then
			player_move(id,-180,2.0*spfak#,silent)
		Else
			player_move(id,0,2.0*spfak#,silent)
		EndIf
	Else
		player\y=ty
		reached=reached+1
	EndIf
	
	;Stuck? -> Abbruch der aktuellen Aktion
	Local stuck=0
	If Int(player\x)=px Then
		If Int(player\y)=py Then
			stuck=1
		EndIf
	EndIf
	If stuck Then
		player\bot_mm_stuck=player\bot_mm_stuck+1
		;Nach 5 Stucks zum Random Movement bergehen
		If player\bot_mm_stuck>5 Then
			player\bot_mm_tx=-1
			player\bot_mm_ty=-1
			player\bot_obj[0]=90
			player\bot_obj[1]=Rand(0,3)
			player\bot_obj[2]=ms
			;Markieren wenn Bot debug aktiviert ist
			If op_debug_bots=1
				For pf_wp.pf_wp=Each pf_wp
					If pf_wp\id=parentwp Then
						x=e_add_sprite_wave(player\x+16,player\y+16,32,1)
						EntityColor x,255,0,0
						Exit
					EndIf
				Next
			EndIf
		EndIf
	Else
		player\bot_mm_stuck=0
	EndIf
	
	;Aktionsberreich erreicht?
	Select map_gametype
		;1 - AS
		Case 1
			;Keine Aktionen
		;2 - CS
		Case 2
			;Hostage benutzen
			If player\team=2 Then
				For hostage.hostage=Each hostage
					If hostage\health>0 Then
						If hostage\followid=-1
							If Abs(hostage\x-player\x)<20 Then
								If Abs(hostage\y-player\y)<20 Then
									player_action(player\id,4,hostage\id)
									player\bot_obj[0]=0
									Exit
								EndIf
							EndIf
						EndIf
					EndIf
				Next
			EndIf
		;3 - DE
		Case 3
			;Bombe legen
			If player\sweapon[7]=55 Then
				If player\tile_entity=5 Then
					If player\action<>2 Then
						player_weapon(player\id,7,55)
						player_action(player\id,2,1)
					EndIf
				EndIf
			EndIf
			;Bombe defusen
			If e_sv_bombtimer>0 Then
				If player\team=2 Then
					If player\action<>3 Then
						If player\tile_entity=5 Then
							For item.item=Each item
								If item\x=player\x/32 Then
									If item\y=player\y/32 Then
										player_action(player\id,3,1)
									EndIf
								EndIf
							Next
						EndIf
					EndIf
				EndIf
			EndIf
			
	End Select
	
	
	;Sub-Target erreicht? -> Nchstes Sub-Target suchen
	If reached=2 Then
		player\bot_mm_tx=-1
		player\bot_mm_ty=-1
	EndIf
	
	;Hauptziel erreicht? -> Neue Aktion suchen
	If player\x/32=player\bot_obj[1] Then
		If player\y/32=player\bot_obj[2] Then
			player\bot_obj[0]=0
			player\bot_mm_tx=-1
			player\bot_mm_ty=-1
		EndIf
	EndIf
End Function


;--------------------Zum Gegner laufen
Function bot_move_enemy(id,enemyid)
	;Player 1 (Bot)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	;Player 2 (Enemy)
	ph=0
	For player2.player=Each player
		If player2\id=enemyid Then ph=1:Exit
	Next
	If Not ph Then Return 0
	
	;Bewegen (X)
	If Abs(player\x-player2\x)>(15) Then
		If player\x<player2\x Then
			player_move(id,90,2.0*spfak#,0)
		Else
			player_move(id,-90,2.0*spfak#,0)
		EndIf
	EndIf
	;Bewegen (Y)
	If Abs(player\y-player2\y)>(15) Then
		If player\y<player2\y Then
			player_move(id,-180,2.0*spfak#,0)
		Else
			player_move(id,0,2.0*spfak#,0)
		EndIf
	EndIf
End Function


;--------------------Bewegen und Gegner beschtzen
Function bot_move_cover(id,mate)
End Function


;--------------------Frei bewegen
Function bot_move_free(id)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	;Cachen
	px=Int(player\x)
	py=Int(player\y)
	
	;Deadly Scan um zu verhindern, dass Spieler auf tdliche Tiles luft
	scok=1
	scx=px+16
	scy=py+16
	Select player\bot_obj[1]
		Case 0 scy=scy-10
		Case 1 scy=scy+10
		Case 2 scx=scx-10
		Case 3 scx=scx+10
	End Select
	scx=scx/32
	scy=scy/32
	If scx>=0 Then
		If scy>=0 Then
			If scx<=map_xsize Then
				If scy<=map_ysize Then
					If map(scx,scy,3)>49 Then
						scok=0
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	
	;Bewegen
	If scok Then
		Select player\bot_obj[1]
			Case 0 player_move(id,0,2.0*spfak#,0)		;UP
			Case 1 player_move(id,-180,2.0*spfak#,0)	;DOWN
			Case 2 player_move(id,-90,2.0*spfak#,0)		;LEFT
			Case 3 player_move(id,90,2.0*spfak#,0)		;RIGHT
			Default player\bot_obj[1]=Rand(0,3)
		End Select
	Else
		player\bot_obj[1]=Rand(0,3)
	EndIf
	
	;Stuck? -> Richtung ndern
	If Int(player\x)=px Then
		If Int(player\y)=py Then
			player\bot_obj[1]=Rand(0,3)
		EndIf
	EndIf
	
	;Ziel erneut anpeilen
	If ms-player\bot_obj[2]>1000 Then
		player\bot_obj[2]=ms
		bot_findtarget(player\id)
	EndIf
End Function




;--------------------Direkter, freier Weg zwischen 2 Koordinaten?
Function bot_directway(x1,y1,x2,y2)
	;Cachen
	Local timeout=MilliSecs()
	If Abs(x1-x2)>500 Then Return 0
	If Abs(y1-y2)>500 Then Return 0
	dir=ATan2(x2-x1,y1-y2)
	xo#=Sin(dir)*10
	yo#=-Cos(dir)*10
	sx#=x1
	sy#=y1
	
	;Loop
	For limit=0 To 50
	
		;Bewegen
		sx#=sx#+xo#
		sy#=sy#+yo#
				
		stx=Int(sx#/32)
		sty=Int(sy#/32)
				
		;Bei Maprand abbrechen
		If stx<0 Then Return 0
		If sty<0 Then Return 0
		If stx>map_xsize Return 0
		If sty>map_ysize Return 0
				
		;Bei Wnden/Hindernissen/Blocks/Deadly abbrechen
		If map(stx,sty,3)>0 And map(stx,sty,3)<5 Then Return 0
		If map(stx,sty,3)>49 Then Return 0
		
		;Ziel
		If stx=Int(x2/32) Then
			If sty=Int(y2/32) Then
				Return 1
			EndIf
		EndIf
		
		;timeout
		If MilliSecs()-timeout>2 Then
			If op_debug Then con_add("Bot Timeout Error: Bot Directway",0,0)
			Return 0
		EndIf

	Next
	Return 0
End Function


;--------------------Direkter, freier Weg zwischen Spieler und Koordinaten?
Function bot_freeway(id,tx,ty)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	;Cachen
	Local x,y
	Local sx#,sy#
	Local stx,sty
	Local dir=0
	Local xo#,yo#
	Local timeout=MilliSecs()
	x=player\x+16
	y=player\y+16
	tx=tx*32
	ty=ty*32
	dir=ATan2(tx+16-(x+16),(y+16)-(ty+16))
	xo#=Sin(dir)*10
	yo#=-Cos(dir)*10
	sx#=x
	sy#=y
	
	;Loop
	Repeat
		
		;Bewegen
		sx#=sx#+xo#
		sy#=sy#+yo#
		
		;<<<DEBUG>>>
		If op_debug_bots Then
			e_add_par2d($FF0000,Rand(200,600),sx#,sy#,0,0)
		EndIf
		;<<<DEBUG>>>
		
		stx=Int(sx#/32)
		sty=Int(sy#/32)
				
		;Bei Maprand abbrechen
		If stx<0 Then Return 0
		If sty<0 Then Return 0
		If stx>map_xsize Return 0
		If sty>map_ysize Return 0
				
		;Bei Wnden/Hindernissen/Blocks/Deadly abbrechen
		If map(stx,sty,3)>0 And map(stx,sty,3)<5 Then Return 0
		If map(stx,sty,3)>49 Then Return 0
		
		;Ziel
		If stx=Int(tx/32) Then
			If sty=Int(ty/32) Then
				Return 1
			EndIf
		EndIf
		
		;timeout
		If MilliSecs()-timeout>3 Then Return 0
		
	Forever
End Function


;--------------------Bot Skills
Function bot_skills(skill)
	Select skill
		Case 1
			hud_m_add("Bot Skills: Newbie")
			op_bot_enemy_rescan(0)=2500
			op_bot_enemy_rescan(1)=4500
			op_bot_walk_rescan(0)=4000
			op_bot_walk_rescan(1)=8000
			op_bot_freeline_rescan(0)=1000
			op_bot_freeline_rescan(1)=2000
			op_bot_rotate=5
		Case 2
			hud_m_add("Bot Skills: Normal")
			op_bot_enemy_rescan(0)=1000
			op_bot_enemy_rescan(1)=2000
			op_bot_walk_rescan(0)=2000
			op_bot_walk_rescan(1)=4000
			op_bot_freeline_rescan(0)=500
			op_bot_freeline_rescan(1)=800
			op_bot_rotate=20
		Case 3
			hud_m_add("Bot Skills: Pro Gamer")
			op_bot_enemy_rescan(0)=100
			op_bot_enemy_rescan(1)=500
			op_bot_walk_rescan(0)=1500
			op_bot_walk_rescan(1)=3500
			op_bot_freeline_rescan(0)=100
			op_bot_freeline_rescan(1)=200
			op_bot_rotate=30
		Case 4
			hud_m_add("Bot Skills: Cheater")
			op_bot_enemy_rescan(0)=30
			op_bot_enemy_rescan(1)=50
			op_bot_walk_rescan(0)=1000
			op_bot_walk_rescan(1)=3000
			op_bot_freeline_rescan(0)=50
			op_bot_freeline_rescan(1)=100
			op_bot_rotate=360
		Default
			hud_m_add("Invalid Skills")
	End Select
	hud_men_set(0)
End Function

;--------------------Bot Modes
Function bot_modes(mode)
	op_bot_mode=mode
	Select mode
		Case 1 hud_m_add("Bot Mode: Normal")
		Case 2 hud_m_add("Bot Mode: Knifes only")
		Case 3 hud_m_add("Bot Mode: Pistols only")
		Case 4 hud_m_add("Bot Mode: Shotguns only")
		Case 5 hud_m_add("Bot Mode: SMGs only")
		Case 6 hud_m_add("Bot Mode: Rifles only")
		Case 7 hud_m_add("Bot Mode: Sniper-Rifles only")
		Case 8 hud_m_add("Bot Mode: MGs only")		
	End Select
	hud_men_set(0)
	For player.player=Each player
		If player\bot=1 Then
			player_bestweapon(player\id)
		EndIf
	Next
End Function