;----------------------------------------Effects (Create Functions)


;--------------------Sprite fragment adden (1)
Function e_add_sprite_fragment(frame,r,g,b,x,y,subtyp=0,fx=0,fy=0,alpha#=1)
	sprite.sprite=New sprite
	sprite\h=CreateSprite()
	EntityTexture sprite\h,gfx_fragments,frame
	sprite\sx#=16
	sprite\sy#=16
	ScaleSprite sprite\h,16,16
	EntityColor sprite\h,r,g,b
	PositionEntity sprite\h,((x)*2)-640+16,-((y)*2)+480-16,640
	EntityOrder sprite\h,order_splatter
	
	sprite\typ=1
	sprite\subtyp=subtyp
	sprite\x#=x
	sprite\y#=y
	sprite\fx=fx
	sprite\fy=fy
	sprite\dir#=Rand(0,360)
	RotateSprite sprite\h,sprite\dir#
	sprite\alpha#=alpha#
	EntityAlpha sprite\h,alpha#
	Return sprite\h
End Function

;--------------------Sprite Knife Slash adden (2)
Function e_add_sprite_knifeslash(x,y,dir)
	dir=dir-15
	sprite.sprite=New sprite
	sprite\h=CreateSprite()
	EntityTexture sprite\h,gfx_knifeslash
	sprite\sx#=32
	sprite\sy#=32
	ScaleSprite sprite\h,32,32
	xo=Sin(dir)*16
	yo=-Cos(dir)*16
	sprite\x#=x
	sprite\y#=y
	PositionEntity sprite\h,((sprite\x#+xo)*2)-640+32,-((sprite\y#+yo)*2)+480-32,640
	EntityOrder sprite\h,order_splatter
	sprite\typ=2
	sprite\dir#=dir
	RotateSprite sprite\h,-dir
	sprite\alpha#=1.0
	EntityAlpha sprite\h,alpha#
	EntityBlend sprite\h,3
End Function

;--------------------Sprite Raindrop adden (3)
Function e_add_sprite_raindrop(x,y)
	sprite.sprite=New sprite
	sprite\h=CreateSprite(cam)
	EntityTexture sprite\h,gfx_raindrop
	Local scale#=Rand(16,32)
	ScaleSprite sprite\h,scale#,scale#
	PositionEntity sprite\h,x,y,Rand(1,-50)
	EntityOrder sprite\h,order_light
	RotateSprite sprite\h,Rand(-5,5)
	EntityAlpha sprite\h,Rand(0.3,0.8)
	EntityColor sprite\h,100,100,Rand(100,140)
	EntityBlend sprite\h,3
	If y<=0 Then
		RotateEntity sprite\h,85,0,-180
	Else
		RotateEntity sprite\h,-85,0,0
	EndIf
	SpriteViewMode sprite\h,2
	sprite\typ=3
	sprite\fx#=Rnd(15.0,25.0)
End Function

;--------------------Sprite Snowflake adden (4)
Function e_add_sprite_snowflake(x,y)
	sprite.sprite=New sprite
	sprite\h=CreateSprite(cam)
	EntityTexture sprite\h,gfx_snowflake
	Local scale#=Rand(4,16)
	ScaleSprite sprite\h,scale#,scale#
	PositionEntity sprite\h,x,y,Rand(1,-10)
	EntityOrder sprite\h,order_light
	EntityAlpha sprite\h,Rand(0.3,0.8)
	EntityBlend sprite\h,3
	sprite\typ=4
	sprite\fx#=Rnd(3.0,5.0)
End Function

;--------------------Sprite Wave adden (5)
Function e_add_sprite_wave(x,y,size#=32,alpha#=0.6)
	sprite.sprite=New sprite
	sprite\h=CreateSprite()
	EntityTexture sprite\h,gfx_wave
	ScaleSprite sprite\h,size#,size#
	PositionEntity sprite\h,((x)*2)-640,-((y)*2)+480,640
	EntityColor sprite\h,230,230,Rand(230,255)
	EntityOrder sprite\h,order_decal
	EntityAlpha sprite\h,alpha#
	EntityBlend sprite\h,3
	sprite\typ=5
	sprite\scale#=size#
	sprite\alpha#=alpha#
	Return sprite\h
End Function

;--------------------Sprite Smokepuff adden (7)
Function e_add_sprite_smokepuff(x,y,size#=32,alpha#=0.6)
	sprite.sprite=New sprite
	sprite\h=CreateSprite()
	EntityTexture sprite\h,gfx_smokepuff
	ScaleSprite sprite\h,size#,size#
	PositionEntity sprite\h,((x)*2)-640,-((y)*2)+480,640
	col=Rand(70,100)
	EntityColor sprite\h,col,col,col
	EntityAlpha sprite\h,alpha#
	dir=Rand(0,360)
	RotateSprite sprite\h,dir
	sprite\dir#=dir
	sprite\typ=7
	sprite\scale#=size#
	sprite\alpha#=alpha#
	sprite\x#=x
	sprite\y#=y
	sprite\sx#=Rnd(-.5,.5)
	sprite\sy#=Rnd(-.5,.5)
	
	;Order
	If e_xspriteorder>order_explosion Or e_xspriteorder<order_explosion_max Then
		e_xspriteorder=order_explosion
	Else
		e_xspriteorder=e_xspriteorder-1
	EndIf
	EntityOrder sprite\h,e_xspriteorder
	
	Return sprite\h
End Function

;--------------------Sprite Fire adden (8)
Function e_add_sprite_fire(x,y,size#=32,alpha#=0.6)
	sprite.sprite=New sprite
	sprite\h=CreateSprite()
	EntityTexture sprite\h,gfx_muzzleflash
	If Rand(5)=1 Then
		size#=size#*5
	Else
		size#=size#*2
	EndIf
	ScaleSprite sprite\h,size#,size#
	PositionEntity sprite\h,((x)*2)-640,-((y)*2)+480,640
	EntityColor sprite\h,255,Rand(0,200),0
	EntityAlpha sprite\h,alpha#
	dir=Rand(0,360)
	RotateSprite sprite\h,dir
	EntityOrder sprite\h, order_light
	EntityBlend sprite\h, 3
	sprite\dir#=dir
	sprite\typ=8
	sprite\scale#=size#
	sprite\alpha#=alpha#
	sprite\x#=x
	sprite\y#=y
	sprite\sx#=Rnd(-.4,.4)
	sprite\sy#=Rnd(-.4,.4)	
	Return sprite\h
End Function

;--------------------Sprite Muzzleflash adden (10)
Function e_add_sprite_muzzleflash(x,y,size,dir,parent=0)
	sprite.sprite=New sprite
	sprite\h=CreateSprite()
	sprite\typ=10
	EntityTexture sprite\h, gfx_muzzleflash
	EntityColor sprite\h,255,Rand(100,255),0
	ScaleSprite sprite\h, size,size
	PositionEntity sprite\h,((x)*2)-640+size,-((y)*2)+480-size,640
	EntityBlend sprite\h,3
	RotateSprite sprite\h,-dir
	If parent<>0 Then
		EntityParent sprite\h,parent
	EndIf
	EntityOrder sprite\h,order_light
	sprite\alpha#=Rand(0.8,1.0)
	Return sprite\h
End Function

;--------------------Sprite Bloodlake adden (20)
Function e_add_sprite_bloodlake(x,y,size,dir,alpha#)
	sprite.sprite=New sprite
	sprite\h=CreateSprite()
	sprite\typ=20
	EntityTexture sprite\h, gfx_bloodlake
	EntityColor sprite\h,Rand(150,255),Rand(0,25),0
	ScaleSprite sprite\h, size,size
	PositionEntity sprite\h,((x)*2)-640,-((y)*2)+480,640
	RotateSprite sprite\h,-dir
	EntityOrder sprite\h,order_decal
	sprite\alpha#=alpha#
	sprite\scale=size
	EntityAlpha sprite\h,alpha#
	Return sprite\h
End Function

;--------------------Sprite Line adden
Function e_add_sprite_line(x1#,y1#,x2#,y2#,r,g,b,alpha#)

	x1=((x1)*2)-640
	y1=-((y1)*2)+480
	x2=((x2)*2)-640
	y2=-((y2)*2)+480

	mesh=CreateMesh()
	EntityFX(mesh,16)
	surf=CreateSurface(mesh)
	verts = 0
	AddVertex surf,x1#,y1#,640,0,0
	AddVertex surf,(x1#+x2#)/2,(y1#+y2#)/2,640,0,0 
	AddVertex surf,x2#,y2#,640,1,0
	AddTriangle surf,verts,verts+2,verts+1
	
	;EntityColor mesh,r,g,b
	;EntityAlpha mesh,alpha#
	
	Return mesh
End Function


;--------------------Sprite Smoke adden
Function e_add_smoke(x,y,size#,fx#,fy#,timer,alpha#=1.0,rot=0)
	smoke.smoke = New smoke
	smoke\h=CreateSprite()
	EntityTexture smoke\h,gfx_smoke,0
	ScaleSprite smoke\h,size#,size#
	PositionEntity smoke\h,((x-size#/4)*2)-640+size#,-((y-size#/4)*2)+480-size#,640
	EntityAlpha smoke\h,alpha#
	RotateSprite smoke\h,rot
	EntityColor smoke\h, 70,70,70
	smoke\x#=x
	smoke\y#=y
	smoke\size#=size#
	smoke\fx#=fx#
	smoke\fy#=fy#
	smoke\timer=ms+timer
	smoke\alpha#=alpha#
	smoke\rot=rot
	
	;Order
	If e_xspriteorder>order_explosion Or e_xspriteorder<order_explosion_max Then
		e_xspriteorder=order_explosion
	Else
		e_xspriteorder=e_xspriteorder-1
	EndIf
	EntityOrder smoke\h,e_xspriteorder
	
	Return smoke\h	
End Function


;--------------------Sprite Explosion adden
Function e_add_explosion(x,y,size=32,alpha#=0.8,glowsprites=5)
	explosion.explosion = New explosion
	explosion\h=CreateSprite()
	EntityTexture explosion\h,gfx_explosion,0
	ScaleSprite explosion\h,size,size
	PositionEntity explosion\h,((x)*2)-640,-((y)*2)+480,640
	EntityAlpha explosion\h,alpha#
	EntityBlend explosion\h,3
	RotateSprite explosion\h,Rand(0,360)
	explosion\x=x
	explosion\y=y
	explosion\frame=0
	explosion\timer=ms
	explosion\size=size

	;Additional FX
	For i=0 To glowsprites
		wink=Rand(0,360)
		e_add_sprite_fire(x+Sin(wink)*(size/5),y-Cos(wink)*(size/5),Rand(8,20),Rnd(1,2.5))
	Next
	
	;Wasser?
	tx=x/32:ty=y/32
	If tx>0 And tx<map_xsize And ty>0 And ty<map_ysize Then
		If map(tx,ty,3)=14 Then
			For i=0 To Rand(1,5)
				e_add_sprite_wave(x+Rand(-30,30),y+Rand(-30,30),Rand(5,20),Rnd(0.5,0.8))
			Next
		EndIf
	EndIf
	
	;Order
	If e_xspriteorder>order_explosion Or e_xspriteorder<order_explosion_max Then
		e_xspriteorder=order_explosion
	Else
		e_xspriteorder=e_xspriteorder-1
	EndIf
	EntityOrder explosion\h,e_xspriteorder
	
	Return explosion\h
End Function


;--------------------Decal adden
Function e_add_decal(x,y,h,frame=0,alpha#=1,r=255,g=255,b=255,timer=5000,rot=0)
	decal.decal=New decal
	decal\h=CreateSprite()
	EntityTexture decal\h,h,frame
	ScaleSprite decal\h,32,32
	If rot<>0 Then RotateSprite decal\h, rot
	PositionEntity decal\h,((x)*2)-640+32,-((y)*2)+480-32,640
	EntityAlpha decal\h, alpha#
	EntityColor decal\h, r,g,b
	EntityOrder decal\h, order_decal
	
	;Wasser?
	tx=x/32:ty=y/32
	If tx>=0 And tx<map_xsize And ty>=0 And ty<map_ysize Then
		If map(tx,ty,3)=14 Then
			alpha#=alpha#-0.5
			EntityAlpha decal\h, alpha#
		EndIf
	EndIf
	
	decal\x=x
	decal\y=y
	decal\alpha#=alpha#
	decal\timer=ms+timer
	Return decal\h
End Function


;--------------------Par2D adden
Function e_add_par2d(col,age,x,y,fx=0,fy=0)
	par2d.par2d=New par2d
	par2d\col=col
	par2d\age=ms+age
	par2d\x=x
	par2d\y=y
	par2d\fx=fx
	par2d\fy=fy
End Function


;--------------------Physical adden (1)
Function e_add_physical(x#,y#,alpha#,timer#,weight#=0.5,fx#=0.0,fy#=0.0)
	physical.physical=New physical
	physical\h=CreateSprite()
	ScaleSprite physical\h,22,22
	EntityTexture physical\h,gfx_bodyparts,Rand(0,7)
	PositionEntity physical\h,((x)*2)-640,-((y)*2)+480,640
	EntityOrder physical\h,order_physical
	RotateSprite physical\h,Rand(360)
	
	physical\x#=x
	physical\y#=y
	physical\alpha#=alpha#
	physical\timer=ms+timer
	physical\weight#=weight#
	physical\fx#=fx#
	physical\fy#=fy#
	EntityAlpha physical\h,alpha#
	Return physical\h
End Function


;--------------------Hurt adden
Function e_add_hurt(enemy=-1,dir=-1,alpha#=1.5)
	;Aus?
	If Not op_hurt Then Return 0
	;Eigenes X
	For player.player=Each player
		If player\id=e_player Then
			ownx=player\x+16
			owny=player\y+16
			Exit
		EndIf
	Next
	;Direction
	If enemy>-1 And enemy<>e_player Then
		For player.player=Each player
			If player\id=enemy Then
				dir=ATan2(ownx-(player\x+16),(player\y+16)-owny)
				Exit
			EndIf
		Next
	;Multiple
	ElseIf dir=-1 Then
		e_add_hurt(-1,0)
		e_add_hurt(-1,90)
		e_add_hurt(-1,-90)
		e_add_hurt(-1,180)
		Return 1
	EndIf	
	;Position
	x=320
	y=240
	x=x-Sin(dir)*50
	y=y+Cos(dir)*50
	x=x-16
	;Sprite
	hud_hurt.hud_hurt=New hud_hurt
	hud_hurt\h=CreateSprite(cam)
	hud_hurt\alpha#=alpha#
	EntityTexture hud_hurt\h,gfx_hud_arrow
	ScaleSprite hud_hurt\h,32,32
	EntityBlend hud_hurt\h,3
	EntityAlpha hud_hurt\h,alpha#
	PositionEntity hud_hurt\h,((x)*2)-640,-((y)*2)+480,640
	EntityColor hud_hurt\h,255,0,0
	RotateSprite hud_hurt\h,-dir
	EntityOrder hud_hurt\h,order_hud_display
	Return hud_hurt\h
End Function




;----------------------------------------Effects (RENDER FUNCTIONS)

;--------------------Render Sprites
Function e_render_sprite()
	For sprite.sprite=Each sprite
		If sprite\timer-ms<0 Then
			Select sprite\typ
				;10 - Muzzleflash
				Case 10
					sprite\alpha#=sprite\alpha#-(0.2*spfak#)
					EntityAlpha sprite\h, sprite\alpha#
					If sprite\alpha#<=0 Then
						FreeEntity sprite\h
						Delete sprite
					EndIf
				;1 - Fragment
				Case 1
					;Bewegung
					If sprite\fx<>0 Then
						If sprite\fx>0 Then
							sprite\fx=sprite\fx-1
						Else
							sprite\fx=sprite\fx+1
						EndIf
						sprite\x#=sprite\x#+Float((Float(Float(sprite\fx)/3.0)*spfak#))
					EndIf
					If sprite\fy<>0 Then
						If sprite\fy>0 Then
							sprite\fy=sprite\fy-1
						Else
							sprite\fy=sprite\fy+1
						EndIf
						sprite\y#=sprite\y#+Float((Float(Float(sprite\fy)/3.0)*spfak#))
					EndIf
					;Wnde etc.
					tx=sprite\x#/32
					ty=sprite\y#/32
					If tx>=0 And tx<=map_xsize Then
						If ty>=0 And ty<=map_ysize Then
							If map(tx,ty,3)=1 Or map(tx,ty,3)=3 Then
								sprite\fx=0
								sprite\fy=0
							ElseIf map(tx,ty,3)>49 And map(tx,ty,3)<54 Then
								sprite\alpha#=sprite\alpha#-(0.05*spfak#)
								EntityAlpha sprite\h, sprite\alpha#
							EndIf
						EndIf
					EndIf
					;Position & Alpha
					PositionEntity sprite\h,((sprite\x#)*2)-640+sprite\sx#,-((sprite\y#)*2)+480-sprite\sy#,640
					If sprite\fx=0 And sprite\fy=0 Then
						sprite\alpha#=sprite\alpha#-(0.01*spfak#)
						EntityAlpha sprite\h, sprite\alpha#
						If sprite\alpha#<=0 Then
							FreeEntity sprite\h
							Delete sprite
						EndIf
					Else
						sprite\dir#=sprite\dir#+sprite\subtyp
						RotateSprite sprite\h,sprite\dir#
					EndIf
				;2 - Knife Slash
				Case 2
					sprite\dir#=sprite\dir#+(6.5*spfak#)
					xo=Sin(sprite\dir#)*16
					yo=-Cos(sprite\dir)*16
					PositionEntity sprite\h,((sprite\x#+xo)*2)-640+32,-((sprite\y#+yo)*2)+480-32,640
					RotateSprite sprite\h, -sprite\dir#
					sprite\alpha#=sprite\alpha#-(0.1*spfak#)
					EntityAlpha sprite\h, sprite\alpha#
					If sprite\alpha#<=0 Then
						FreeEntity sprite\h
						Delete sprite
					EndIf
				;3 - Raindrop
				Case 3
					TranslateEntity sprite\h,0,0,sprite\fx#*spfak#
					If EntityZ(sprite\h)>640 Then
						FreeEntity sprite\h
						Delete sprite
					EndIf
				;4 - Snow
				Case 4
					TranslateEntity sprite\h,Rnd(-1,1)*spfak#,Rnd(-1,1)*spfak#,sprite\fx#*spfak#
					If EntityZ(sprite\h)>640 Then
						FreeEntity sprite\h
						Delete sprite
					EndIf
				;5 - Wave
				Case 5
					sprite\alpha#=sprite\alpha#-(0.02*spfak#)
					sprite\scale#=sprite\scale#+(0.8*spfak#)
					ScaleSprite sprite\h,sprite\scale#,sprite\scale#
					EntityAlpha sprite\h,sprite\alpha#
					EntityAlpha sprite\h, sprite\alpha#
					If sprite\alpha#<=0 Then
						FreeEntity sprite\h
						Delete sprite
					EndIf
				;6 - Bomb Blink
				Case 6
					sprite\alpha#=sprite\alpha#-(0.05*spfak#)
					EntityAlpha sprite\h, sprite\alpha#
					If sprite\alpha#<=0 Then
						FreeEntity sprite\h
						Delete sprite
					EndIf
				;7 - Smokepuff
				Case 7
					sprite\alpha#=sprite\alpha#-(0.005*spfak#)
					sprite\dir#=sprite\dir#+(1*spfak#)
					sprite\x#=sprite\x#+((sprite\sx#+map_storm_x#)*spfak#)
					sprite\y#=sprite\y#+((sprite\sy#+map_storm_y#)*spfak#)
					sprite\scale#=sprite\scale#+(0.3*spfak#)
					ScaleSprite sprite\h, sprite\scale#,sprite\scale#
					EntityAlpha sprite\h, sprite\alpha#
					RotateSprite sprite\h,sprite\dir#
					PositionEntity sprite\h,((sprite\x#)*2)-640,-((sprite\y#)*2)+480,640
					If sprite\alpha#<=0 Then
						FreeEntity sprite\h
						Delete sprite
					EndIf
				;8 - Fire
				Case 8
					sprite\alpha#=sprite\alpha#-(0.02*spfak#)
					sprite\dir#=sprite\dir#-(10*spfak#)
					sprite\x#=sprite\x#+((sprite\sx#+map_storm_x#)*spfak#)
					sprite\y#=sprite\y#+((sprite\sy#+map_storm_y#)*spfak#)
					sprite\scale#=sprite\scale#+(0.3*spfak#)
					ScaleSprite sprite\h, sprite\scale#,sprite\scale#
					EntityAlpha sprite\h, sprite\alpha#
					RotateSprite sprite\h,sprite\dir#
					PositionEntity sprite\h,((sprite\x#)*2)-640,-((sprite\y#)*2)+480,640
					If sprite\alpha#<=0 Then
						FreeEntity sprite\h
						Delete sprite
					EndIf
				;20 - Bloodlake
				Case 20
					sprite\alpha#=sprite\alpha#-(0.001*spfak#)
					If sprite\scale<40 Then sprite\scale#=sprite\scale#+(0.03*spfak#)
					ScaleSprite sprite\h, sprite\scale#,sprite\scale#
					EntityAlpha sprite\h, sprite\alpha#
					If sprite\alpha#<=0 Then
						FreeEntity sprite\h
						Delete sprite
					EndIf
			End Select
		EndIf
	Next
End Function

;--------------------Render Smoke
Function e_render_smoke()
	For smoke.smoke=Each smoke
		If smoke\fx#<>0.0 Then smoke\x#=smoke\x#+(smoke\fx#*spfak#)
		If smoke\fy#<>0.0 Then smoke\y#=smoke\y#+(smoke\fy#*spfak#)
		smoke\size#=smoke\size#+(0.4*spfak#)
		If sp50go Then smoke\rot=smoke\rot+1
		ScaleSprite smoke\h, smoke\size#, smoke\size#
		PositionEntity smoke\h,(smoke\x#*2)-640,-(smoke\y#*2)+480,640
		If ms-smoke\timer>0 Then
			smoke\alpha#=smoke\alpha#-(0.01*spfak#)
			EntityAlpha smoke\h, smoke\alpha#
			If smoke\alpha#<=0 Then
				FreeEntity smoke\h
				Delete smoke
			EndIf
		EndIf
	Next
End Function


;--------------------Render Explosion
Function e_render_explosion()
	For explosion.explosion=Each explosion
		If ms-explosion\timer>100 Then
			explosion\frame=explosion\frame+1
			If explosion\frame<10 Then
				EntityTexture explosion\h,gfx_explosion,explosion\frame
				explosion\timer=ms
				If explosion\frame<7 Then
					For i=0 To Rand(1,5)
						par2d.par2d=New par2d
						par2d\col=$FFFF00
						par2d\age=ms+Rand(100,300)
						par2d\x=explosion\x+explosion\size/4
						par2d\y=explosion\y+explosion\size/4
						par2d\fx=Rand(-15,15)
						par2d\fy=Rand(-15,15)
					Next
				EndIf
			Else
				FreeEntity explosion\h
				Delete explosion
			EndIf
		EndIf
	Next
End Function


;--------------------Render Decal
Function e_render_decal()
	For decal.decal=Each decal
		If ms-decal\timer>0 Then
			decal\alpha#=decal\alpha#-(0.005*spfak#)
			EntityAlpha decal\h, decal\alpha#
			If decal\alpha#<=0 Then
				FreeEntity decal\h
				Delete decal
			EndIf
		EndIf
	Next
End Function


;--------------------Render Par2D
Function e_render_par2d()
	If e_dedicated=1 Or op_particles=0 Then
		For par2d.par2d=Each par2d
			Delete par2d
		Next
	Else
		LockBuffer BackBuffer()
		For par2d.par2d=Each par2d
			If ms-par2d\age>0 Then
				Delete par2d
			Else
				If par2d\fx<>0 Then
					If par2d\fx>0 Then
						par2d\fx=par2d\fx-1
					Else
						par2d\fx=par2d\fx+1
					EndIf
					If par2d\fx>3 Then
						par2d\x=par2d\x+(3*spfak#)
					Else
						par2d\x=par2d\x+(par2d\fx*spfak#)
					EndIf
				EndIf
				If par2d\fy<>0 Then
					If par2d\fy>0 Then
						par2d\fy=par2d\fy-1
					Else
						par2d\fy=par2d\fy+1
					EndIf
					If par2d\fy>3 Then
						par2d\y=par2d\y+(3*spfak#)
					Else
						par2d\y=par2d\y+(par2d\fy*spfak#)
					EndIf
				EndIf
				
				If (par2d\x-(e_x*32-e_px))>0 Then
					If (par2d\y-(e_y*32-e_py))>0 Then
						If (par2d\x-(e_x*32-e_px))<640 Then
							If (par2d\y-(e_y*32-e_py))<480 Then
								WritePixelFast par2d\x-(e_x*32-e_px),par2d\y-(e_y*32-e_py),par2d\col
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		Next
		UnlockBuffer BackBuffer()
	EndIf
End Function

;--------------------Render Physical
Function e_render_physical()
	For physical.physical=Each physical
		
		;Wnde -> Abprallen
		tx=Int(physical\x#)/32
		ty=Int(physical\y#)/32
		If tx>=0 Then
			If ty>=0 Then
				If tx<=map_xsize Then
					If ty<=map_ysize Then
						If map(tx,ty,3)>0 And map(tx,ty,3)<4 Then
							physical\fx#=-physical\fx#
							physical\fy#=-physical\fy#
						ElseIf map(tx,ty,3)>49 And map(tx,ty,3)<54 Then
							physical\timer=0
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
		
		;Bewegen + Langsamer werden
		If physical\fx#<>0.0 Then
			physical\x#=physical\x#+((physical\fx#)*spfak#)
			e_add_par2d($D20000,Rand(400,7000),physical\x,physical\y,Rand(-5,5),Rand(-5,5))
			If physical\fx#>0.0 Then
				physical\fx#=physical\fx#-physical\weight#*spfak#
				If physical\fx#<0.0 Then physical\fx#=0.0
			Else
				physical\fx#=physical\fx#+physical\weight#*spfak#
				If physical\fx#>0.0 Then physical\fx#=0.0
			EndIf
		EndIf
		If physical\fy#<>0.0 Then
			physical\y#=physical\y#+((physical\fy#)*spfak#)
			e_add_par2d($D20000,Rand(400,7000),physical\x,physical\y,Rand(-5,5),Rand(-5,5))
			If physical\fy#>0.0 Then
				physical\fy#=physical\fy#-physical\weight#*spfak#
				If physical\fy#<0.0 Then physical\fy#=0.0
			Else
				physical\fy#=physical\fy#+physical\weight#*spfak#
				If physical\fy#>0.0 Then physical\fy#=0.0
			EndIf
		EndIf
		PositionEntity physical\h,((physical\x#)*2)-640,-((physical\y#)*2)+480,640
		
		;Ausfaden
		If physical\timer-ms<0 Then
			physical\alpha#=physical\alpha#-(0.01*spfak#)
			EntityAlpha physical\h, physical\alpha#
			If physical\alpha#<=0 Then
				FreeEntity physical\h
				Delete physical
			EndIf
		EndIf
		
	Next
End Function


;--------------------Render HUD
Function e_render_hud()
	For hud_hurt.hud_hurt=Each hud_hurt
		hud_hurt\alpha#=hud_hurt\alpha#-(0.03*spfak#)
		EntityAlpha hud_hurt\h,hud_hurt\alpha#
		If hud_hurt\alpha#<=0.0 Then
			FreeEntity hud_hurt\h
			Delete hud_hurt
		EndIf
	Next
End Function