;----------------------------------------Engine

;--------------------Initiale
Function e_ini()
	
	;Fog of War
	fow_pivot=CreatePivot(cam)
	fow_mesh=CreateMesh()
	fow_surf=CreateSurface(fow_mesh)
	For x=0 To 22
		For y=0 To 17
			fow_v(x,y)=AddVertex(fow_surf,((x*32)*2)-640,-((y*32)*2)+480,640)
			VertexColor fow_surf,fow_v(x,y),0,0,0,.65
		Next
	Next
	For x=0 To 21
		For y=0 To 16
			v1=fow_v(x,y)
			v2=fow_v(x+1,y)
			v3=fow_v(x,y+1)
			v4=fow_v(x+1,y+1)
			AddTriangle(fow_surf,v2,v3,v1)
			AddTriangle(fow_surf,v4,v3,v2)	
		Next
	Next
	UpdateNormals(fow_mesh)
	EntityFX fow_mesh,34
	EntityParent(fow_mesh,fow_pivot)
	EntityOrder fow_mesh,order_fow
	
	;Shadows
	If op_mapshadows=1 Then
		sha_pivot=CreatePivot(cam)
		For x=0 To 21
			For y=0 To 16
				sha_h(x,y)=CreateSprite()
				EntityColor sha_h(x,y),0,0,0
				EntityAlpha sha_h(x,y),0.6
				ScaleSprite sha_h(x,y),32,32
				PositionEntity sha_h(x,y),((x*32)*2)-640+32,-((y*32)*2)+480-32,640
				EntityParent sha_h(x,y),sha_pivot
				EntityOrder sha_h(x,y),order_shadowmap
			Next
		Next
	EndIf
	
End Function


;--------------------Clear
Function e_cls(clearudpstack=1)
	
	;UDP
	If clearudpstack=1 Then
		For udp_data_h.udp_data_h=Each udp_data_h
			Delete udp_data_h
		Next
		For udp_data.udp_data=Each udp_data
			Delete udp_data
		Next
	EndIf
	
	;Fog of War
	If fow_pivot<>0 Then
		FreeEntity fow_pivot
		fow_pivot=0
	EndIf
	
	;Shadows
	If sha_pivot<>0 Then
		FreeEntity sha_pivot
		sha_pivot=0
	EndIf
	
	;Entities lschen
	For entity.entity=Each entity
		;env_sprite
		If entity\typ=22 And entity\h<>0 Then FreeEntity entity\h
		Delete entity
	Next
	For entityc.entityc=Each entityc
		Delete entityc
	Next
	
	;Ressourcen lschen
	For source.source=Each source
		Select source\typ
			;Sound
			Case 0 If source\h<>0 Then FreeSound source\h
			;Texture
			Case 1 If source\h<>0 Then FreeTexture source\h
			;Image
			Case 2 If source\h<>0 Then FreeImage source\h
		End Select
		Delete source
	Next
	
	;Players lschen
	For player.player=Each player
		If player\h<>0 Then FreeEntity player\h
		Delete player
	Next
	
	;Hostages lschen
	For hostage.hostage=Each hostage
		If hostage\h<>0 Then FreeEntity hostage\h
		Delete hostage
	Next
	
	;Granaten lschen
	For grenade.grenade=Each grenade
		FreeEntity grenade\h
		Delete grenade
	Next

	;Items lschen
	For item.item=Each item
		FreeEntity item\h
		Delete item
	Next
	
	;Decals lschen
	For decal.decal=Each decal
		FreeEntity decal\h
		Delete decal
	Next

	;Smokes lschen
	For smoke.smoke=Each smoke
		FreeEntity smoke\h
		Delete smoke
	Next

	;Explosions lschen
	For explosion.explosion=Each explosion
		FreeEntity explosion\h
		Delete explosion
	Next	

	;Sprites lschen
	For sprite.sprite=Each sprite
		If sprite\typ<>10 Then FreeEntity sprite\h
		Delete sprite
	Next
	
	;Physicals lschen
	For physical.physical=Each physical
		FreeEntity physical\h
		Delete physical
	Next

	;2D Partikel lschen
	For par2d.par2d=Each par2d
		Delete par2d
	Next
	
	;Waypoints lschen
	For pf_wp.pf_wp=Each pf_wp
		Delete pf_wp
	Next
	
	;Links Lschen
	For pf_link.pf_link=Each pf_link
		Delete pf_link
	Next
	
	;HUD Hurts lschen
	For hud_hurt.hud_hurt=Each hud_hurt
		FreeEntity hud_hurt\h
		Delete hud_hurt
	Next
	
	;Expls lschen
	For expl.expl=Each expl
		Delete expl
	Next
	
	;Globals
	player_marker=0
	player_olddir=0
	
	;Engine HUD
	If hud_main<>0 Then FreeEntity hud_main:hud_main=0
	hud_main_living=0
	hud_main_dead=0
	Dim hud_health(3)
	Dim hud_armory(3)
	Dim hud_time(5)
	Dim hud_ammo(6)
	Dim hud_money(5)
	Dim hud_borders(1)
	Dim hud_symbols(1)
	;Dim hud_sniper(4)
	hud_sniper_main=0
	hud_board=0
	hud_body=0
	hud_radar=0
	hud_progress=0
	hud_progress_bar=0
	hud_flash=0
	hud_nv=0
	hud_radar_on=1
	
	
	;Engine Globals
	e_x=0
	e_y=0
	e_px=0
	e_py=0
	
	e_bot=0
	e_bot_join=0
	
	e_server=-5
	e_player=-1
	e_team=0
	e_active=0
	
	e_sv_ip=0
	e_sv_port=0
	e_sv_name$=0
	e_sv_pw$=0
	e_sv_maxplayers=0
	e_sv_fow=0:ch_fow=e_sv_fow*ch_fak:ch_fow2=e_sv_fow*ch_fak2
	e_sv_score_t=0
	e_sv_score_ct=0
	e_sv_winrow_t=0
	e_sv_winrow_ct=0
	e_sv_restart=0
	e_sv_restart_mode=0
	e_sv_playergive=0
	e_sv_playergiven=0
	e_sv_ff=0

	e_rt_ms=0
	e_rt_s=0
	e_rt_m=0
	
	e_lastrr=0
	
	e_getbytes=0
	e_getbytes_f=0

	e_quake#=0.0

	e_entityspriteorder=0
	e_xspriteorder=0
	
	e_starttime=0
	
	
	;HUD Globals
	hud_nv_mode=0
	hud_flash_a#=0.0
	
	
	;Alte UDP Nachrichten lschen
	If udp<>0 Then
		While RecvUDPMsg(udp)
			While ReadAvail(udp)
				ReadByte(udp)
			Wend
		Wend
	EndIf
	
	;Cam zurcksetzen
	PositionEntity cam,0,0,0
	
	;Wireframe
	op_wireframe=0
	WireFrame 0
	
End Function

;--------------------Tiles Laden
Function e_loadtiles(file$,ed=0)
	Local dotpos,count,name$,xsize,ysize,stream,i
	
	If gfx_tiles<>0 Then FreeImage gfx_tiles: gfx_tiles=0
	If gfx_tiles_temp<>0 Then FreeImage gfx_tiles_temp: gfx_tiles_temp=0
	
	If Instr(file$,".")=0 Then file$=file$+".bmp"
	
	If FileType("gfx/tiles/"+file$)<>1 Then
		If ed Then
			file$="normal.bmp"
		Else
			con_add("Error: Can't find '"+file$+"'!",0)
			Return 0
		EndIf
	EndIf
	If FileType("gfx/tiles/normal.bmp")<>1 Then RuntimeError("Can't find 'gfx/tiles/normal.bmp'!")
	
	;Gre bestimmen
	ctiles=LoadImage("gfx/tiles/"+file$)
	xsize=ImageWidth(ctiles)
	ysize=ImageHeight(ctiles)
	xsize=Int(xsize/32)
	ysize=Int(ysize/32)
	maxcount=xsize*ysize
	FreeImage ctiles
	If ed Then
		count=maxcount
	Else
		count=map_tilesc+1
		If count>maxcount Then count=maxcount
	EndIf
	If count>256 Then count=256
	
	;Grafiken laden & maskieren
	gfx_tiles=LoadAnimImage("gfx/tiles/"+file$,32,32,0,count)
	gfx_tiles_temp=LoadAnimImage("gfx/tiles/"+file$,32,32,0,count)
	MaskImage gfx_tiles,255,0,255
	MaskImage gfx_tiles_temp,255,0,255
	
	;Info laden
	Dim tile_mode(count-1)
	dotpos=Instr(file$,".")
	name$=Left(file$,dotpos-1)
	If FileType("gfx/tiles/"+name$+".inf")=1 Then
		stream=ReadFile("gfx/tiles/"+name$+".inf")
		ReadLine(stream)
		For i=0 To count-1
			tile_mode(i)=ReadLine(stream)
		Next
		CloseFile(stream)
		ed_tile_mc=1
	Else
		ed_tile_mc=0
	EndIf
	
	;Speichern
	map_tileset$=file$
	map_tilesc=count-1
	
	Return 1
End Function


;--------------------Map laden
Function e_map_load(name$,root$="maps/")
	Local x,y,i,header$,stream,ec
	
	;lschen
	e_cls()
	
	;Existiert Map?
	If FileType(root$+name$+".map")<>1 Then
		con_add("Error: Can't find "+name$+".map!",0)
		Return 0
	EndIf
	
	;Waypoints
	map_waypoints=e_waypoints_load(name$)
	
	;Lesen
	con_add("Loading "+name$+".map",0)
	stream=ReadFile(root$+name$+".map")
	
	;ID-Header
	header$=ReadLine(stream)
	If Instr(header$, "Unreal Software's Counter-Strike 2D Map File")=0 Then
		con_add("Error: Can't load "+name$+".map - no Counter-Strike 2D map!",0)
		Return 0
	EndIf
	
	;Fakes
	map_back_scr_tile=ReadByte(stream)
	For i=1 To 9
		ReadByte(stream)
	Next
	For i=1 To 10
		ReadInt(stream)
	Next
	For i=1 To 10
		ReadLine(stream)
	Next
	
	;Map Header
	map_code$=ReadLine(stream)
	map_name$=name$
	map_tileset$=ReadLine(stream)
	map_tilesc=ReadByte(stream):Local map_tilesc_loaded=map_tilesc
	map_xsize=ReadInt(stream)
	map_ysize=ReadInt(stream)
	map_back$=ReadLine(stream)
	map_back_h=0
	map_back_x=0
	map_back_y=0
	map_back_scr_x=ReadInt(stream)
	map_back_scr_y=ReadInt(stream)
	map_bg_r=ReadByte(stream)
	map_bg_g=ReadByte(stream)
	map_bg_b=ReadByte(stream)
	map_storm_x#=0
	map_storm_y#=0
	
	;Maximale Gre
	If map_xsize>10000 Then map_xsize=10000:con_add("Error: Invalid X-Size",0,0)
	If map_ysize>10000 Then map_ysize=10000:con_add("Error: Invalid Y-Size",0,0)
			
	;Background Color/Image initialisieren
	ClsColor map_bg_r,map_bg_g,map_bg_b
	If map_back$<>"" And Instr(map_back$,".")=0 Then map_back$=map_back$+".jpg"
	If FileType("gfx/backgrounds/"+map_back$)=1 Then
		map_back_h=LoadImage("gfx/backgrounds/"+map_back$)
	Else
		map_back_h=0
	EndIf
	
	;zwischen-Test
	header$=ReadLine(stream)
	If header$<>"ed.erawtfoslaernu" Then
		con_add("Error: Can't load "+name$+".map - invalid/damaged map header!",0)
		Return 0
	EndIf
		
	;Tile Modes
	If Not e_loadtiles(map_tileset$) Then Return 0
	Dim tile_mode(map_tilesc_loaded)
	For i=0 To map_tilesc_loaded
		tile_mode(i)=ReadByte(stream)
	Next
	
	;Tiles
	Dim map(map_xsize,map_ysize,3)
	For x=0 To map_xsize
		For y=0 To map_ysize
			map(x,y,0)=ReadByte(stream)
			If map(x,y,0)>map_tilesc Then
				map(x,y,0)=0
				map(x,y,3)=tile_mode(0)
			Else
				map(x,y,3)=tile_mode(map(x,y,0))
			EndIf
		Next
	Next
		
	;Entities
	ec=ReadInt(stream)
	If ec>10000 Then ec=10000:con_add("Error: Invalid Entity Count",0,0)
	For i=1 To ec
		entity.entity=New entity
		entity\name$=ReadLine(stream)
		entity\typ=ReadByte(stream)
		entity\h=0
		entity\x=ReadInt(stream)
		entity\y=ReadInt(stream)
		entity\trigger$=ReadLine(stream)
		For x=0 To 9
			entity\value_int[x]=ReadInt(stream)
			entity\value_str$[x]=ReadLine(stream)
		Next
	Next
	
	;In Entities verwendete Ressourcen laden / Enities einstellen
	For entity.entity=Each entity
		Select entity\typ
			;inf_animation
			Case 8
				entity\value_int[8]=entity\value_int[0]
			;inf_storm
			Case 9
				map_storm_x#=Float(Sin(entity\value_int[0])*entity\value_int[1])/10.0
				map_storm_y#=Float(-Cos(entity\value_int[0])*entity\value_int[1])/10.0
			;env_sprite
			Case 22
				e_res_load(entity\value_str$[0],1,entity\value_str$[2])
				e_setup_sprite(entity\x,entity\y)
			;env_sound
			Case 23
				entity\h=e_res_load(entity\value_str$[0],0)
			;env_image
			Case 28
				entity\h=e_res_load(entity\value_str$[0],2)
		End Select
	Next
	
	;Entities Cachen
	For entity.entity=Each entity
		entityc.entityc=New entityc
		entityc\name$=entity\name$
		entityc\typ=entity\typ
		entityc\h=entity\h
		entityc\x=entity\x
		entityc\y=entity\y
		entityc\trigger$=entity\trigger$
		For x=0 To 9
			entityc\value_int[x]=entity\value_int[x]
			entityc\value_str$[x]=entity\value_str$[x]
		Next
	Next
	
	;Entities in Map Array speichern
	;Leeren
	For x=0 To map_xsize
		For y=0 To map_ysize
			map(x,y,1)=-1
		Next
	Next
	;Flche
	Local ax,ay,a
	For entity.entity=Each entity
		If entity_area(entity\typ)>0 Then
			a=entity_area(entity\typ)
			For ax=entity\x-a To entity\x+a
				For ay=entity\y-a To entity\y+a
					If ax>=0 Then
						If ay>=0 Then
							If ax<=map_xsize Then
								If ay<=map_ysize Then
									map(ax,ay,1)=entity\typ
								EndIf
							EndIf
						EndIf
					EndIf
				Next
			Next
		EndIf
	Next
	;Punkt
	For entity.entity=Each entity
		If entity\x>=0 Then
			If entity\y>=0 Then
				If entity\x<=map_xsize Then
					If entity\y<=map_ysize Then
						map(entity\x,entity\y,1)=entity\typ
					EndIf
				EndIf
			EndIf
		EndIf
	Next
	;Dynamic Walls (env_breakable)
	For entity.entity=Each entity
		If entity\typ=25 Then
			If entity\x>=0 Then
				If entity\y>=0 Then
					If entity\x<=map_xsize Then
						If entity\y<=map_ysize Then
							If entity\value_int[6]=0 Then
								map(entity\x,entity\y,3)=1	;Wall (Shadow)
							ElseIf entity\value_int[6]=1 Then
								map(entity\x,entity\y,3)=3	;Block (no Shadow)
							Else
								map(entity\x,entity\y,3)=2	;Obstacle (Obstacle Shadow)
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	Next
	;Overwrite Entities (lschen Flchen wieder
	For entity.entity=Each entity
		;info_nobuying
		If entity\typ=11 Then
			For x=0 To map_xsize
				For y=0 To map_ysize
					If map(x,y,1)<3 Then map(x,y,1)=-1
				Next
			Next
		EndIf
	Next
	
	;Map Cachen
	Dim map_c(map_xsize,map_ysize,3)
	For x=0 To map_xsize
		For y=0 To map_ysize
			map_c(x,y,0)=map(x,y,0)
			map_c(x,y,1)=map(x,y,1)
			map_c(x,y,2)=map(x,y,2)
			map_c(x,y,3)=map(x,y,3)
		Next
	Next
	
	;Auf 0|0 setzen
	e_x=0
	e_y=0
	
	;Start Time setzen
	e_starttime=MilliSecs()
	
	;Schlieen
	CloseFile(stream)
	
	;Info Text?
	map_briefing=0
	Dim map_info$(17)
	If FileType(root$+name$+".txt")=1 Then
		stream=ReadFile(root$+name$+".txt")
		i=0
		While Not Eof(stream)
			map_info$(i)=ReadLine(stream)
			i=i+1
			If i=18 Then Exit
		Wend
		CloseFile(stream)
		map_briefing=1
	EndIf
	
	e_map_reset(0)
	
	;Mapcycle
	e_sv_mapcyclems=MilliSecs()
	e_sv_round=0
	
	;Ausgabe
	con_add("Map "+name$+".map loaded",0)
	hud_mapload=1
	Return 1
		
End Function

;--------------------Map speichern
Function e_map_save(name$)
	Local x,y,i,stream,ec

	;Waypoints
	e_waypoints_save(name$)

	;Schreiben
	con_add("Saving "+name$+".map",0)
	stream=WriteFile("maps/"+name$+".map")
	
	;ID-Header
	WriteLine stream,"Unreal Software's Counter-Strike 2D Map File"
	
	;Fakes
	WriteByte stream, map_back_scr_tile
	For i=1 To 9
		WriteByte stream, 0
	Next
	For i=1 To 10
		WriteInt stream, 0
	Next
	For i=1 To 10
		WriteLine stream, " "
	Next
	
	;Map Header
	map_code$=map_xsize*map_ysize+"x"+map_tilesc+"$"+Replace(CurrentTime(),":","")+"%"+MilliSecs()
	WriteLine stream, map_code$
	map_name$=name$
	WriteLine stream, map_tileset$
	WriteByte stream, map_tilesc
	WriteInt stream, map_xsize
	WriteInt stream, map_ysize
	WriteLine stream, map_back$
	WriteInt stream, map_back_scr_x
	WriteInt stream, map_back_scr_y
	WriteByte stream, map_bg_r
	WriteByte stream, map_bg_g
	WriteByte stream, map_bg_b
	
	;zwischen-Test
	WriteLine stream, "ed.erawtfoslaernu"
	
	;Tile Modes
	For i=0 To map_tilesc
		WriteByte stream, tile_mode(i)
	Next
	
	;Tiles
	For x=0 To map_xsize
		For y=0 To map_ysize
			WriteByte stream, map(x,y,0)
		Next
	Next
	
	;Entities
	ec=0
	For entity.entity = Each entity
		ec=ec+1
	Next
	WriteInt stream, ec
	For entity.entity = Each entity
		WriteLine stream, entity\name$
		WriteByte stream, entity\typ
		WriteInt stream, entity\x
		WriteInt stream, entity\y
		WriteLine stream, entity\trigger$
		For x=0 To 9
			WriteInt stream, entity\value_int[x]
			WriteLine stream, entity\value_str$[x]
		Next
	Next
	
	;Schlieen
	CloseFile(stream)
	
	;Ausgabe
	con_add("Map "+name$+".map saved",0)
	Return 1
	
End Function


;--------------------Map reset
Function e_map_reset(recache=1)
	Local x,y, i
	
	If recache Then
	
		;Entities aus Cache zurckladen
		For entity.entity=Each entity
			;Sounds stoppen
			If entity\typ=23 Then
				If ChannelPlaying(entity\value_int[9]) Then
					StopChannel(entity\value_int[9])
				EndIf
			EndIf
			Delete entity
		Next
		For entityc.entityc=Each entityc
			entity.entity=New entity
			entity\name$=entityc\name$
			entity\typ=entityc\typ
			entity\h=entityc\h
			entity\x=entityc\x
			entity\y=entityc\y
			entity\trigger$=entityc\trigger$
			For x=0 To 9
				entity\value_int[x]=entityc\value_int[x]
				entity\value_str$[x]=entityc\value_str$[x]
			Next
		Next
		
		;Map aus Cache zurckladen
		For x=0 To map_xsize
			For y=0 To map_ysize
				map(x,y,0)=map_c(x,y,0)
				map(x,y,1)=map_c(x,y,1)
				map(x,y,2)=map_c(x,y,2)
				map(x,y,3)=map_c(x,y,3)
			Next
		Next
		
	EndIf
	
	;Time
	e_rt_m=5
	e_rt_s=0
	e_rt_ms=MilliSecs()
	
	;Bomb
	e_sv_bombtimer=0
	e_sv_bombblink=0
	
	;Granaten lschen
	For grenade.grenade=Each grenade
		FreeEntity grenade\h
		Delete grenade
	Next
	
	;Items lschen
	For item.item=Each item
		FreeEntity item\h
		Delete item
	Next
	
	;Rauchwolken lschen
	For smoke.smoke=Each smoke
		FreeEntity smoke\h
		Delete smoke
	Next
	
	;Geiseln
	i=0
	For hostage.hostage=Each hostage
		FreeEntity hostage\h
		Delete hostage
	Next
	For entity.entity=Each entity
		If entity\typ=3 Then
			If i>=256 Then
				con_add("Error: Hostage overflow!",0,1)
				Exit
			EndIf
			hostage.hostage=New hostage
			hostage\h=CreateSprite()
			ScaleSprite hostage\h, 32,32
			EntityOrder hostage\h, order_player
			hostage\id=i
			hostage\x=entity\x*32
			hostage\y=entity\y*32
			hostage\dir=entity\value_int[0]
			hostage\health=100
			hostage\used=0
			hostage\followid=-1
			EntityTexture hostage\h,gfx_players,9+entity\value_int[1]
			RotateSprite hostage\h,-hostage\dir
			PositionEntity hostage\h,((hostage\x)*2)-640+32,-((hostage\y)*2)+480-32,640
			i=i+1
		EndIf
	Next
	
	;Items
	For entity.entity=Each entity
		If entity\typ=21 Then
			e_setup_item(entity\value_int[0],entity\x,entity\y,weapon_ammo(entity\value_int[0]),weapon_ammoin(entity\value_int[0]))
		EndIf
	Next
	
	;Decals
	For entity.entity=Each entity
		If entity\typ=24 Then
			For decal.decal=Each decal
				If decal\x/32=entity\x Then
					If decal\y/32=entity\y Then
						FreeEntity decal\h
						Delete decal
					EndIf
				EndIf
			Next
			If entity\value_int[0]>=0 And entity\value_int[0]<=15 Then
				e_add_decal(entity\x*32,entity\y*32,gfx_decals,entity\value_int[0],entity\value_str$[0],entity\value_int[1],entity\value_int[2],entity\value_int[3],60*1000*100,entity\value_int[4])
			Else
				con_add("Warning: Can't setup Decal, invalid frame!")
			EndIf
		EndIf
	Next
	
	;Bloodlakes
	For sprite.sprite=Each sprite
		If sprite\typ=20 Then
			FreeEntity sprite\h
			Delete sprite
		EndIf
	Next
	
	;Expls lschen
	For expl.expl=Each expl
		Delete expl
	Next
	
	e_shadows()
	
End Function


;--------------------Map testen
Function e_map_check()
	Local tbase
	Local ctbase
	Local vip
	Local escape
	Local hostage
	Local bomb
	
	For entity.entity=Each entity
		Select entity\typ
			Case 0 tbase=tbase+1
			Case 1 ctbase=ctbase+1
			Case 2 vip=vip+1
			Case 3 hostage=hostage+1
			Case 5 bomb=bomb+1
			Case 6 escape=escape+1
		End Select
	Next
	
	map_gametype=0
	If vip>0 Or escape>0 Then map_gametype=1
	If hostage>0 Then map_gametype=2
	If bomb>0 Then map_gametype=3
	
	If map_gametype=1 Then
		If vip=0 Then e_cls():con_add("Error: Invalid AS-Map. info_vip entity is missing!",0,1):leave=1:men_msg("Invalid AS-Map",2,0):Return 0
		If escape=0 Then e_cls():con_add("Error: Invalid AS-Map. info_escapepoint entity is missing!",0,1):leave=1:men_msg("Invalid AS-Map",2,0):Return 0
	EndIf
	
	If tbase=0 Or ctbase=0 Then e_cls():con_add("Error: Invalid Map. info_t/info_ct entity is missing!",0,1):leave=1:men_msg("Invalid Map",2,0):Return 0
	
	Return 1
End Function


;--------------------Waypoints laden
Function e_waypoints_load(file$)
	Local i,stream,wpc,lc,wp1x,wp1y,wp2x,wp2y
	
	;Existiert Waypointfile?
	If FileType("bots/waypoints/"+file$+".wps")<>1 Or FileSize("bots/waypoints/"+file$+".wps")<5 Then
		hud_m_add("No waypoints for this map!",3000)
		con_add("Warning: No waypoints for this map!",0,1)
		Return 0
	EndIf
	
	;Lesen
	stream=ReadFile("bots/waypoints/"+file$+".wps")
	
	;Waypoints einlesen
	For pf_wp.pf_wp=Each pf_wp
		Delete pf_wp
	Next
	wpc=ReadInt(stream)
	For i=1 To wpc
		pf_wp.pf_wp=New pf_wp
		pf_wp\id=ReadInt(stream)
		pf_wp\x=ReadInt(stream)
		pf_wp\y=ReadInt(stream)
	Next
	
	;Links einlesen
	For pf_link.pf_link=Each pf_link
		Delete pf_link
	Next
	lc=ReadInt(stream)
	For i=1 To lc
		pf_link.pf_link=New pf_link
		pf_link\wp1=ReadInt(stream)
		pf_link\wp2=ReadInt(stream)
	Next
	
	;Link Distanzen errechnen
	For pf_link.pf_link=Each pf_link
		For pf_wp.pf_wp=Each pf_wp
			If pf_wp\id=pf_link\wp1 Then
				wp1x=pf_wp\x*32+16
				wp1y=pf_wp\y*32+16
				Exit
			EndIf
		Next
		For pf_wp.pf_wp=Each pf_wp
			If pf_wp\id=pf_link\wp2 Then
				wp2x=pf_wp\x*32+16
				wp2y=pf_wp\y*32+16
				Exit
			EndIf
		Next
		pf_link\cost=Sqr((wp1x-wp2x)^2+(wp1y-wp2y)^2)
	Next
	
	;Schlieen
	CloseFile(stream)
	
	;Waypoints zhlen
	wpc=0
	For pf_wp.pf_wp=Each pf_wp
		wpc=wpc+1
	Next
	;Links zhlen
	lc=0
	For pf_link.pf_link=Each pf_link
		lc=lc+1
	Next
	
	If wpc>1 And lc>=1 Then
		Return 1
	Else
		Return 0
	EndIf
End Function


;--------------------Waypoints Speichern
Function e_waypoints_save(file$)
	Local i,stream,wpc,lc
	
	;Doppelte Connections lschen
	If 1=0 Then
	For pf_l1.pf_link=Each pf_link
		For pf_l2.pf_link=Each pf_link
			If pf_l1\wp1=pf_l2\wp1 Then
				If pf_l1\wp2=pf_l2\wp2 Then
					Delete pf_l2
				EndIf
			ElseIf pf_l1\wp1=pf_l2\wp2 Then
				If pf_l1\wp2=pf_l2\wp1 Then
					Delete pf_l2
				EndIf
			EndIf
		Next
	Next
	EndIf
	
	;Bei 0 Waypoints nix speichern!
	wpc=0
	For pf_wp.pf_wp=Each pf_wp
		wpc=wpc+1
	Next
	If wpc<=0 Then Return 0
	
	;Schreiben
	stream=WriteFile("bots/waypoints/"+file$+".wps")
	
	;Waypoints schreiben
	wpc=0
	For pf_wp.pf_wp=Each pf_wp
		wpc=wpc+1
	Next
	WriteInt stream,wpc
	For pf_wp.pf_wp=Each pf_wp
		WriteInt stream, pf_wp\id
		WriteInt stream, pf_wp\x
		WriteInt stream, pf_wp\y
	Next
	
	;Links schreiben
	lc=0
	For pf_link.pf_link=Each pf_link
		lc=lc+1
	Next
	WriteInt stream,lc
	For pf_link.pf_link=Each pf_link
		WriteInt stream, pf_link\wp1
		WriteInt stream, pf_link\wp2
	Next
	
	;Schlieen
	CloseFile(stream)
	Return 1
End Function



;--------------------Ressourcen laden
Function e_res_load$(file$,typ,mode=0)
	Local stream
	
	;Schon vorhanden?
	For source.source=Each source
		If source\file$=file$ Then
			If source\typ=typ Then
				If source\mode=mode Then
					Return source\h
				EndIf
			EndIf
		EndIf
	Next
	
	;Laden
	source.source=New source
	source\file$=file$
	source\typ=typ
	source\mode=mode
	Select typ
		;Sound
		Case 0
			If FileType(file$)<>1 Then con_add("Warning: Can't load "+file$,0): Return 0
			source\h=LoadSound(file$)
			Return source\h
		;Texture
		Case 1
			If FileType(file$)<>1 Then con_add("Error: Can't load "+file$,0): Return 0
			source\h=LoadTexture(file$,mode)
			Return source\h
		;Image
		Case 2
			If FileType(file$)<>1 Then con_add("Error: Can't load "+file$,0): Return 0
			source\h=LoadImage(file$)
			MaskImage source\h,255,0,255
			Return source\h
		;Text
		Case 3
			If FileType(file$)=1 Then
				stream=ReadFile(file$)
				While Not Eof(stream)
					source\value_str$=source\value_str$+ReadLine(stream)+"|"
				Wend
				CloseFile(stream)
			EndIf
			Return source\value_str$
		;Unbekannt
		Default 
			Return 0
	End Select
	
	Return 1
End Function


;--------------------Ressourcen Handle ausgeben
Function e_res_get(file$,typ,mode=0)
	;Suchen
	For source.source=Each source
		If source\file$=file$ Then
			If source\typ=typ Then
				If source\mode=mode Then
					Return source\h
				EndIf
			EndIf
		EndIf
	Next
	;Nicht gefunden
	Return 0
End Function


;--------------------Map rendern
Function e_render(bg=1, tiles=1, ed=0)
	Local x,y,xp,yp,sx,sy,ex,ey
	
	;Background
	If bg Then
		If map_back_h<>0 Then
			If Not map_back_scr_tile Then		
				TileBlock map_back_h,map_back_x,map_back_y
				If sp50go Then
					map_back_x=map_back_x+map_back_scr_x
					map_back_y=map_back_y+map_back_scr_y
				EndIf
			Else
				TileBlock map_back_h,(e_x*32)+e_px+map_back_x,(e_y*32)+e_py+map_back_y
				If sp50go Then
					map_back_x=map_back_x+map_back_scr_x
					map_back_y=map_back_y+map_back_scr_y
				EndIf
			EndIf
		Else
			Cls
		EndIf
	Else
		Color 0,0,0
		Rect 0,0,640,480,1
	EndIf
	
	;Tiles zeichnen
	If tiles Then
		xp=e_px
		yp=e_py
		sx=e_x
		sy=e_y
		ex=e_x+20
		ey=e_y+15
		If sx<0 Or sy<0 Then en=1
		If ex>map_xsize Then ex=map_xsize
		If ey>map_ysize Then ey=map_ysize
		x=0
		y=0

		For x=sx To ex
			yp=e_py
			For y=sy To ey
				If x>=0 Then
					If y>=0 Then
						DrawImage gfx_tiles_temp, xp, yp, map(x,y,0)
					EndIf
				EndIf
				yp=yp+32
			Next
			xp=xp+32
		Next
	EndIf
	
	;Editor Rahmen
	If ed Then
		If sx<0 Or sy<0 Or (e_x+20)>map_xsize Or (e_y+15)>map_ysize Then
			Color 50,50,50
			xp=e_px
			yp=e_py
			For x=0 To 20
				yp=e_py
				For y=0 To 15
					If (e_x+x)<0 Then
						Rect xp,yp,32,32,1
					ElseIf (e_x+x)>map_xsize Then
						Rect xp,yp,32,32,1
					ElseIf (e_y+y)<0 Then
						Rect xp,yp,32,32,1
					ElseIf (e_y+y)>map_ysize Then
						Rect xp,yp,32,32,1
					EndIf
					yp=yp+32
				Next
				xp=xp+32
			Next
		EndIf
	EndIf
	
	;Cam Positionieren
	PositionEntity cam, (e_x*32-e_px)*2,-(e_y*32-e_py)*2,0

End Function


;--------------------Fog of War (FoW) Berechnen
Function e_fow(id)
	If fow_pivot=0 Then Return 0
	If e_active=0 Or e_sv_fow=0 Then
		;Kein Fog of War -> hide
		HideEntity fow_pivot
		For player.player=Each player
			If player\team=1 Or player\team=2 Then
				If player\health>0 Then
					ShowEntity player\h
					player\fowhide=0
					player\fowalpha#=1.0
					EntityAlpha player\h,player\fowalpha#
					EntityAlpha player\weapon_h,player\fowalpha#
					EntityAlpha player\equipment_h,player\fowalpha#
					EntityAlpha player\shadow_h,player\fowalpha#-0.6
					EntityAlpha player\legs_h,player\fowalpha#
				EndIf
			EndIf
		Next
		Return 0
	Else
		;Fog of War -> show, positionieren
		ShowEntity fow_pivot
		PositionEntity fow_pivot, ((e_px)*2),-((e_py)*2),0
	EndIf

	Dim fow_layer(21,16)
	
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	Local rx=player\x+16				;Root X
	Local ry=player\y+16				;Root Y
	Local rdir=player\dir				;Root Dir
	
	Local w								;Winkel
	Local ws=rdir-85					;Winkel Start
	Local we=rdir+85					;Winkel End
	
	Local sx#,sy#,xo#,yo#,stx,sty,fowx,fowy,alpha#
	
	;9 Felder um Spielfigur aufhellen
	For x=-1 To 1
		For y=-1 To 1
			fowx=((rx+x*32)-e_x*32)/32
			fowy=((ry+y*32)-e_y*32)/32
			If fowx>-1 Then
				If fowy>-1 Then
					If fowx<22 Then
						If fowy<17 Then
							fow_layer(fowx,fowy)=1
						EndIf
					EndIf
				EndIf
			EndIf
		Next
	Next
	
	
	;Sichtwinkel durchgehen
	For w=ws To we Step 5
		
		;Positionieren
		sx#=rx
		sy#=ry
		xo#=Sin(w)*12
		yo#=-Cos(w)*12
		
		;Strahl senden
		Repeat
		
			;Bewegen
			sx#=sx#+xo#
			sy#=sy#+yo#
			stx=Int((sx#)/32)
			sty=Int((sy#)/32)
			fowx=(sx#-e_x*32)/32
			fowy=(sy#-e_y*32)/32
					
			;Bei Maprand abbrechen
			If stx<0 Then Exit
			If sty<0 Then Exit
			If stx>map_xsize Then Exit
			If sty>map_ysize Then Exit	
			
			;Bei FoW Layer Rand abbrechen
			If fowx<0 Then Exit
			If fowy<0 Then Exit
			If fowx>21 Then Exit
			If fowy>16 Then Exit
			
			;Aufhellen
			fow_layer(fowx,fowy)=1
			
			;Bei Wnden abbrechen
			If map(stx,sty,3)=1 Then Exit
			If map(stx,sty,3)=3 Then Exit
			
			
		Forever
	Next
	
	;25 Felder um Flare Grenades aufhellen
	For grenade.grenade=Each grenade
		If grenade\typ=54 Then
			If grenade\fly<0 Then
				grx=grenade\x+16
				gry=grenade\y+16
				For x=-2 To 2
					For y=-2 To 2
						fowx=((grx+x*32)-e_x*32)/32
						fowy=((gry+y*32)-e_y*32)/32
						If fowx>-1 Then
							If fowy>-1 Then
								If fowx<22 Then
									If fowy<17 Then
										fow_layer(fowx,fowy)=1
									EndIf
								EndIf
							EndIf
						EndIf
					Next
				Next
			EndIf
		EndIf
	Next
	
	;info_NoFow Entities
	For entity.entity=Each entity
		If entity\typ=13 Then
			For x=-1 To 1
				For y=-1 To 1
					fowx=entity\x-e_x+x
					fowy=entity\y-e_y+y
					If fowx>-1 Then
						If fowy>-1 Then
							If fowx<22 Then
								If fowy<17 Then
									fow_layer(fowx,fowy)=1
								EndIf
							EndIf
						EndIf
					EndIf
				Next
			Next
		EndIf
	Next
	
	;Vertices anpassen (SOFT FADING)
	If op_softfow=1 Then
		prevx=0
		prevy=0
		For x=0 To 21
			For y=0 To 16
				If y=0 Then prevx=1:prevy=1
				If x=0 Then prevx=1
						
				If fow_layer(x,y)=1 Then
					If (prevy=1) And (prevx=1) Then
						If fow_layer_old(x,y)>0 Then fow_layer_old(x,y)=fow_layer_old(x,y)-1
						alpha#=.65*Float(Float(fow_layer_old(x,y))/10.0)
						VertexColor fow_surf,fow_v(x,y),0,0,0,alpha#
					Else
						If fow_layer_old(x,y)<10 Then fow_layer_old(x,y)=fow_layer_old(x,y)+1
						alpha#=.65*Float(Float(fow_layer_old(x,y))/10.0)
						VertexColor fow_surf,fow_v(x,y),0,0,0,alpha#
					EndIf
				Else
					If fow_layer_old(x,y)<10 Then fow_layer_old(x,y)=fow_layer_old(x,y)+1
					alpha#=.65*Float(Float(fow_layer_old(x,y))/10.0)
					VertexColor fow_surf,fow_v(x,y),0,0,0,alpha#
				EndIf
				If x<21 And y<16 Then prevy=fow_layer(x,y)
				If x<21 And x>0 And y<16 Then prevx=fow_layer(x-1,y)
			Next
		Next
	;Vertices anpassen (NO FADING)
	Else
		prevx=0
		prevy=0
		For x=0 To 21
			For y=0 To 16
				If y=0 Then prevx=1:prevy=1
				If x=0 Then prevx=1
						
				If fow_layer(x,y)=1 Then
					If (prevy=1) And (prevx=1) Then
						VertexColor fow_surf,fow_v(x,y),0,0,0,0
					Else
						VertexColor fow_surf,fow_v(x,y),0,0,0,.65
					EndIf
				Else
					VertexColor fow_surf,fow_v(x,y),0,0,0,.65
				EndIf
				If x<21 And y<16 Then prevy=fow_layer(x,y)
				If x<21 And x>0 And y<16 Then prevx=fow_layer(x-1,y)
			Next
		Next
	EndIf

	
	
	;Spieler im Schatten verstecken
	For player.player=Each player
		If player\health>0 Then
			If player\team=1 Or player\team=2 Then
				
				fowx=((Int(player\x)+16)-e_x*32)/32
				fowy=((Int(player\y)+16)-e_y*32)/32
				
				;Show/Hide
				player\fowhide=1
				If fowx>-1 Then
					If fowy>-1 Then
						If fowx<22 Then
							If fowy<17 Then
								If fow_layer(fowx,fowy)=1 Then
									player\fowhide=0
								Else
									player\fowhide=1
								EndIf
								
								ShowEntity player\h
							EndIf
						EndIf
					EndIf
				EndIf
				
				;Fadeout
				If player\fowhide=1 Then
					If player\fowalpha#>0.0 Then
						player\fowalpha#=player\fowalpha#-0.1*spfak#
						If player\fowalpha#<0.0 Then
							player\fowalpha#=0.0
							HideEntity player\h
						EndIf
					EndIf
				;Fadein
				Else
					If player\forcedeath=0 Then ShowEntity player\h
					If player\fowalpha#<1.0 Then
						player\fowalpha#=player\fowalpha#+0.1*spfak#
						If player\fowalpha#>1.0 Then player\fowalpha#=1.0
					EndIf
				EndIf	
				
				EntityAlpha player\h,player\fowalpha#
				EntityAlpha player\weapon_h,player\fowalpha#
				EntityAlpha player\equipment_h,player\fowalpha#
				EntityAlpha player\shadow_h,player\fowalpha#-0.6
				EntityAlpha player\legs_h,player\fowalpha#
						
			EndIf
		EndIf
	Next
End Function


;--------------------Shadows anzeigen
Function e_sha()
	If Not op_mapshadows Then Return
	If sha_pivot=0 Then Return 0
	
	Local inmap
	PositionEntity sha_pivot, (e_px*2),-(e_py*2),0
	
	;Sprites anpassen
	For x=0 To 21
		For y=0 To 16
			inmap=0
			If e_x+x>=0 Then
				If e_x+x<=map_xsize Then
					If e_y+y>=0 Then
						If e_y+y<=map_ysize Then
							inmap=1
							If sha_map(e_x+x,e_y+y)=0 Then
								HideEntity sha_h(x,y)
							Else
								ShowEntity sha_h(x,y)
								EntityTexture sha_h(x,y),gfx_shadowmap,sha_map(e_x+x,e_y+y)-1
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
			If inmap=0 Then HideEntity sha_h(x,y)
		Next
	Next
End Function


;--------------------Mittig auf Spieler scrollen
Function e_scroll2player(id)
	Local x,y
	For player.player = Each player
		If player\id=id Then
			x=player\x
			y=player\y
			e_x=(x/32)
			e_y=(y/32)
			e_px=(e_x*32)-x
			e_py=(e_y*32)-y
			e_x=e_x-9
			e_y=e_y-7
			Return 1
		EndIf
	Next
	Return 0
End Function


;--------------------Tile in Karte?
Function e_inmap(x,y)
	If x<0 Then Return 0
	If y<0 Then Return 0
	If x>map_xsize Then Return 0
	If y>map_ysize Then Return 0
	Return 1
End Function


;--------------------Sound (3D)
Function e_sound(sound,x,y,vol#=1,dadd=0)
	Local chan,pan#,lx,ly,dif,dx,dy
	
	;Listener Position Berechnen (Bildmitte)
	lx=(e_x+10)*32+e_px
	ly=(e_y+7)*32+e_py+16
	
	;Pan berechnen
	pan#=0
	dif=x-lx
	pan#=Float(dif)/500.0
	
	;Volume berechnen
	If e_dedicated Then
		vol#=0
	Else
		If lx>x Then
			dx=lx-x
		Else
			dx=x-lx
		EndIf
		If ly>y Then
			dy=ly-y
		Else
			dy=y-ly
		EndIf
		vol#=vol#-Float(dx+dy+dadd)/1000
		vol#=vol#-(1.-op_volume#)
	EndIf
	
	;Abspielen und Pan und Volume setzen
	chan=PlaySound(sound)
	ChannelPan chan,pan#
	ChannelVolume chan,vol#
	
	;Chan zurckgeben
	Return chan
End Function

;--------------------Play
Function e_play(sound,vol#=1.,pan#=0.)
	Local chan
	
	;Volume berechnen
	If e_dedicated Then
		vol#=0
	Else
		vol#=vol#-(1.-op_volume#)
	EndIf
	
	;Abspielen und Pan und Volume setzen
	chan=PlaySound(sound)
	ChannelPan chan,pan#
	ChannelVolume chan,vol#
	
	;Chan zurckgeben
	Return chan
End Function

;--------------------Sound Updaten
Function e_sound_update(chan,x,y,vol#=1,dadd=0)

	;Listener Position Berechnen (Bildmitte)
	lx=(e_x+10)*32+e_px
	ly=(e_y+7)*32+e_py+16
	
	;Pan berechnen
	pan#=0
	dif=x-lx
	pan#=Float(dif)/500.0
	
	;Volume berechnen
	If e_dedicated Then
		vol#=0
	Else
		If lx>x Then
			dx=lx-x
		Else
			dx=x-lx
		EndIf
		If ly>y Then
			dy=ly-y
		Else
			dy=y-ly
		EndIf
		vol=vol#-Float(dx+dy+dadd)/1000
	EndIf
	
	;Pan und Volume setzen
	ChannelPan chan,pan#
	ChannelVolume chan,vol#
	
	;Chan zurckgeben
	Return chan
End Function

;--------------------Tilearea
Function e_tilearea(tilex,tiley,posx,posy)
	Local rx,ry
	rx=posx-(tilex*32)
	ry=posy-(tiley*32)
	;Auerhalb des Tiles? (0)
	If rx<0 Then Return 0
	If ry<0 Then Return 0
	If rx>32 Then Return 0
	If ry>32 Then Return 0
	;Oben (1,2,3)
	If ry<5 Then
		If rx<5 Then Return 1
		If rx<=27 Then
			Return 2
		Else
			Return 3
		EndIf
	;Unten (7,8,9)
	ElseIf ry>27 Then
		If rx<5 Then Return 7
		If rx<=27 Then
			Return 8
		Else
			Return 9
		EndIf
	;Mitte (4,5,6)
	Else
		If rx<5 Then Return 4
		If rx<=27 Then
			Return 5
		Else
			Return 6
		EndIf
	EndIf
End Function

;--------------------Tile Entity
Function e_tile_entity(x,y)
	If x<0 Then Return -1
	If y<0 Then Return -1
	If x>map_xsize Then Return -1
	If y>map_ysize Then Return -1
	Return map(x,y,1)
End Function

;--------------------Mini Map
Function e_minimap(advanced=0,center=0)
	SetBuffer ImageBuffer(gfx_minimap)
	Color 0,0,0
	Rect 0,0,100,100,1
	LockBuffer()
	Local x,y
	Local tx,ty
	Local sx,sy
	
	If Not center Then
		sx=e_x-50+9
		sy=e_y-50+7
	Else
		sx=-50+9
		sy=-50+7
	EndIf
	
	tx=sx
	ty=sy
	
	For x=0 To 100
		ty=sy
		For y=0 To 100
			If tx>-1 Then
				If ty>-1 Then
					If tx<=map_xsize Then
						If ty<=map_ysize Then
							If map(tx,ty,0)<>0 Then
								If map(tx,ty,3)=1 Then
									WritePixelFast x,y,$FFFFFF
								ElseIf map(tx,ty,3)=2 Then
									WritePixelFast x,y,$AAAAAA
								Else
									WritePixelFast x,y,$444444
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
			ty=ty+1
		Next
		tx=tx+1
	Next
	UnlockBuffer()
	
	If advanced=1 Then
		For player.player=Each player
			If player\team=1 Or player\team=2 Then
				If player\health>0
					If player\team=1 Then
						Color 255,50,50
						Plot (player\x/32)-sx,(player\y/32)-sy
					Else
						Color 50,150,255
						Plot (player\x/32)-sx,(player\y/32)-sy
					EndIf
				EndIf
			EndIf
		Next
		For hostage.hostage=Each hostage
			If hostage\health>0 Then
				Color 255,255,0
				Plot (hostage\x/32)-sx,(hostage\y/32)-sy
			EndIf
		Next
	EndIf
	
	
	SetBuffer BackBuffer()
End Function

Function e_shadows()
	;Shadows
	Dim sha_map(map_xsize,map_ysize)
	For x=1 To map_xsize
		For y=1 To map_ysize
			;Auf -1 (kein Schatten) setzen
			sha_map(x,y)=-1
			If map(x,y,3)>=1 And map(x,y,3)<=3 Then
			Else
				;X-Schatten
				If map(x-1,y,3)=1 Then sha_map(x,y)=6
				If map(x-1,y,3)=2 Then sha_map(x,y)=7
				;Y-Schatten
				If map(x,y-1,3)=1 Then
					If sha_map(x,y)=-1 Then sha_map(x,y)=0
					If sha_map(x,y)=6 Then sha_map(x,y)=10
					If sha_map(x,y)=7 Then sha_map(x,y)=11
				ElseIf map(x,y-1,3)=2 Then
					If sha_map(x,y)=-1 Then sha_map(x,y)=1
					If sha_map(x,y)=6 Then sha_map(x,y)=12
					If sha_map(x,y)=7 Then sha_map(x,y)=13
				EndIf
				;Schatten kannten
				If sha_map(x,y)=-1 Then
					If map(x-1,y-1,3)=1 Then sha_map(x,y)=4
					If map(x-1,y-1,3)=2 Then sha_map(x,y)=5
				EndIf
				;X-Ecken abrunden
				If sha_map(x,y)=0 Or sha_map(x,y)=1 Then
					If map(x-1,y-1,3)<1 Or map(x-1,y-1,3)>2 Then
						sha_map(x,y)=sha_map(x,y)+2
					EndIf
				EndIf
				;Y-Ecken abrunden
				If sha_map(x,y)=6 Or sha_map(x,y)=7 Then
					If map(x-1,y-1,3)<1 Or map(x-1,y-1,3)>2 Then
						sha_map(x,y)=sha_map(x,y)+2
					EndIf
				EndIf
			EndIf
			;Erhhen damit 0 = kein Schatten und 1 = Frame 1
			sha_map(x,y)=sha_map(x,y)+1
		Next
	Next
End Function


;Beenden
Function e_shutdown()
	;Logging
	If logfile<>0 Then
		CloseFile(logfile)
		If op_debug_log=0 Then
			If FileType(logfilename$)=1 Then
				DeleteFile(logfilename$)
			EndIf
		EndIf
	EndIf
	
	;End
	End
End Function

;Cachen
Function e_ls(file$)
	stream=ReadFile("temp/mset_"+file$)
	If Not stream Then Return 0
	in$=ReadLine(stream)
	CloseFile(stream)
	Return in$
End Function
Function e_ss(file$,var$)
	stream=WriteFile("temp/mset_"+file$)
	If Not stream Then Return 0
	WriteLine(stream,var$)
	CloseFile(stream)
	Return 1
End Function