;----------------------------------------Misc Functions

;--------------------String splitten
Function split(txt$, sign$=",",limit=10)
	Local num, p1, p2
	num=0
	Dim splits$(limit)
	For num=0 To limit
		p1=p2
		p2=Instr(txt$, sign$, p1+1)
		splits$(num)=Mid(txt$, p1+1, p2-(p1+1))
		If p2=0 Then Return
	Next
End Function



;--------------------Mesh Sprite erstellen
Function meshsprite()
	Local h,surf
	Local v1,v2,v3,v4
	h=CreateMesh()
	surf=CreateSurface(h)
	v1=AddVertex(surf,0,0,0):VertexTexCoords surf,v1,0,0
	v2=AddVertex(surf,1,0,0):VertexTexCoords surf,v2,0,1
	v3=AddVertex(surf,0,1,0):VertexTexCoords surf,v3,1,0
	v4=AddVertex(surf,1,1,0):VertexTexCoords surf,v4,1,1
	AddTriangle(surf,v3,v2,v1)
	AddTriangle(surf,v4,v2,v3)
	UpdateNormals(h)
	RotateMesh h, 0,0,-90
	ScaleMesh h,2,2,1
	PositionMesh h,-1,1,0
	Return h
End Function




;--------------------Bild Prfen
Function scanimage(image$,mr=0,mg=0,mb=0)
	Local r=0,g=0,b=0,x,y,h,w,rgb,cim
	cim=LoadImage(image$)
	h=ImageHeight(cim)
	w=ImageWidth(cim)
	SetBuffer ImageBuffer(cim)
	LockBuffer ImageBuffer(cim)
		For x=0 To w
			For y=0 To h
				rgb=ReadPixelFast(x,y)
				r=r+((rgb And $FF0000)/$10000)
				g=g+((rgb And $FF00)/$100)
				b=b+(rgb And $FF)
			Next
		Next
	UnlockBuffer ImageBuffer(cim)
	SetBuffer BackBuffer()
	FreeImage(cim)
	r=r/(x*y)
	g=g/(x*y)
	b=b/(x*y)
	If (mr+mg+mb)>0 Then
		modified=0
		If Abs(r-mr)>10 Then modified=1
		If Abs(g-mg)>10 Then modified=1
		If Abs(b-mb)>10 Then modified=1
		If modified Then RuntimeError("Modified Image detected!")
	EndIf
End Function




;--------------------Copy
Function copy(txt$)
	Local cb_TEXT=1
	If txt$="" Then Return 
	If OpenClipboard(0)
		EmptyClipboard
		SetClipboardData cb_TEXT,txt$
		CloseClipboard
	EndIf
End Function

;--------------------Paste
Function paste$()
	Local cb_TEXT=1
	Local txt$=""
	If OpenClipboard(0)
		If ExamineClipboard(cb_TEXT) 
			txt$=GetClipboardData$(cb_TEXT)
		EndIf
		CloseClipboard
	EndIf
	Return txt$
End Function


;--------------------Angle (return a value between 0 - 360 of a number)
Function ang(angle)
	If angle>360 Then
		While angle>360
			angle=angle-360
		Wend
	ElseIf angle<0 Then
		While angle<0
			angle=angle+360
		Wend
	EndIf
	Return angle
End Function