;----------------------------------------Game Basic

;--------------------Game Server initialisieren
Function game_server_ini(map$,net,bots=0,maxpl=32,name$="Botserver",pw$="",lport=-1,hide=0,fow=0,warmode=0)
	
	;Players lschen
	For player.player=Each player
		If player\h<>0 Then FreeEntity player\h
		Delete player
	Next
	
	;Console ffnen
	con_y=480
	con_mode=2
	con_add("",0,0)
	If net Then
		con_add("----- Starting Net Game",0,1)
	Else
		con_add("----- Starting Bot Game",0,1)
	EndIf	
	
	;Map Laden
	load_screen("Loading")
	If Not e_map_load(map$) Then
		men_msg("Map Error",2,0)
		Return 0
	EndIf
	If Not e_map_check() Then
		men_msg("Map Error",2,0)
		Return 0
	EndIf
	
	;UDP Stream & Port
	If lport<>-1 Then		
		If udp<>0 Then
			If UDPStreamPort(udp)<>lport Then
				CloseUDPStream(udp)
				udp=0
			EndIf
		EndIf
		udp_ini(lport)
		If udp_chk() Then Return 0
		If lport<>0 Then
			If UDPStreamPort(udp)<>lport Then con_add("Warning: Can't use selected Port!",0,1)
		EndIf
	Else
		If udp=0 Then
			udp_ini()
			If udp_chk() Then Return 0
		EndIf
	EndIf
	
	;USGN Anmeldung
	If net Then
		If Not hide Then
			e_sv_ip=tcp_setserver(UDPStreamPort(udp))
			If e_sv_ip<>0 Then
				e_sv_usgnupdate=0
				con_add("USGN: Server Address is "+DottedIP(e_sv_ip)+":"+UDPStreamPort(udp),0,1)
			Else
				e_sv_usgnupdate=1
				e_sv_usgnupdatetimer=ms
			EndIf
		EndIf
	EndIf
	
	;Bots
	e_bot_join=bots
	e_bot=0
	If net=0 Then e_bot=1
	
	;Selber Joinen
	e_player=player_add(op_nick$,0,0,0)
	e_server=e_player
	
	;Server einstellen
	If name$="" Then name$="No Name Server"
	e_sv_name$=name$
	e_sv_pw$=pw$
	e_sv_port=UDPStreamPort(udp)
	If maxpl<=0 Or maxpl>32 Then maxpl=32
	e_sv_maxplayers=maxpl
	e_sv_fow=fow:ch_fow=e_sv_fow*ch_fak:ch_fow2=e_sv_fow*ch_fak2
	e_sv_warmode=warmode:ch_warmode=e_sv_warmode*ch_fak
	e_rt_m=5
	e_rt_s=0
	e_rt_ms=MilliSecs()
	e_sv_rsession=0
		
	;HUD initialisieren
	hud_hud_ini()
	
	;Zur Gameschleife
	leave=2
	hud_men_set(1)
	parse("exec server.cfg")
	Return 1
End Function


;--------------------Game Client initialisieren
Function game_client_ini(map$,mapcode$,clientid,svid,svip,svport)
	
	;Console ffnen
	con_y=480
	con_mode=0
	con_add("",0,0)
	con_add("----- Starting Net Game",0,1)

	;Map Laden
	load_screen("Loading")
	If Not e_map_load(map$) Then
		men_msg("Map does not exist.",2)
		WriteByte(udp),250
		WriteByte(udp),5
		SendUDPMsg(udp,e_sv_ip,e_sv_port)
		Return 0
	EndIf
	If Not e_map_check() Then
		WriteByte(udp),250
		WriteByte(udp),5
		SendUDPMsg(udp,e_sv_ip,e_sv_port)
		Return 0
	EndIf
	con_add("",0,0)
	
	;Server ID, IP & Port definieren
	e_server=svid
	e_sv_ip=svip
	e_sv_port=svport
	
	;Erfolgreich?
	If map_code$<>mapcode$ Then
		;250:5 - Nein
		men_msg("Your map differs from the servers!",2)
		WriteByte(udp),250
		WriteByte(udp),5
		SendUDPMsg(udp,e_sv_ip,e_sv_port)
		Return 0
	Else
		;250:4 - Ja
		con_add("Sent 250:4",0,1)
		WriteByte(udp),250
		WriteByte(udp),4
		WriteLine(udp),op_nick$
		WriteByte(udp),clientid
		SendUDPMsg(udp,e_sv_ip,e_sv_port)
		
		;HUD initialisieren
		hud_hud_ini()
		hud_hud_update()
		
		;Zur Gameschleife
		con_add("Loading Game Data...")
		loaddatatimer=MilliSecs()
		While MilliSecs()-loaddatatimer<1500
			udp_get()
			e_render(1,1,0)
			RenderWorld()
			con_render(sp25go,15,240)
			Flip
		Wend
		con_mode=2
		leave=2
		hud_men_set(1)
		Return 1
	EndIf
End Function

;--------------------Game Roundend?
Function game_roundend(forceend=0,timeend=0)
	If Not forceend Then
		If e_sv_restart=0 Then
			;Draw
			If player_count_living(0)=0 Then
				game_startround(0,5000,1):Return 1
			;CT Win (all T's dead)
			ElseIf player_count_living(1)=0 Then
				If e_sv_bombtimer=0 Then
					If player_count(1)>0 Then
						game_startround(20,5000,1):Return 1
					Else
						game_startround(0,5000,1):Return 1
					EndIf
				EndIf
			;T Win (all CT's dead)
			ElseIf player_count_living(2)=0 Then
				If player_count(2)>0 Then
					game_startround(10,5000,1):Return 1
				Else
					game_startround(0,5000,1):Return 1
				EndIf
			;Custom
			ElseIf timeend=1 Then
				game_startround(0,5000,1):Return 1
			EndIf
		EndIf
	Else
		If e_sv_restart=0 Then
			Select forceend
				;1 - VIP killed
				Case 1 game_startround(11,5000,1):Return 1
				;2 - VIP Rescued
				Case 2 game_startround(21,5000,1):Return 1
				;3 - Bomb exploded
				Case 3 game_startround(12,5000,1):Return 1
				;4 - Bombspot protected
				Case 4
				;5 - Bomb defused
				Case 5 game_startround(22,5000,1):Return 1
				;6 - Hostages Rescued
				Case 6 game_startround(23,5000,1):Return 1
				;7 - Hostages protected
			End Select
		EndIf
	EndIf
	Return 0
End Function

;--------------------Game Startround
Function game_startround(mode=0,timer=0,send=1)
	;---------------------------------------------------------Pre-restart-Message/Sound:
	If timer<>0 Then
		e_sv_restart=ms+timer
		e_sv_restart_mode=mode
		Select mode
		
			;0 - Draw
			Case 0 hud_m_add("Round Draw",3000):e_play(sfx_r_rounddraw)
			
			;10 - Terrorists win
			Case 10 hud_m_add("Terrorists Win!",3000):e_play(sfx_r_terwin):e_sv_winrow_t=e_sv_winrow_t+1:e_sv_winrow_ct=0
			
			;11 - Terrorists win - VIP killed
			Case 11
				hud_m_add("VIP has been assassinated!",3000):e_play(sfx_r_terwin):e_sv_winrow_t=e_sv_winrow_t+1:e_sv_winrow_ct=0
				If e_player=e_server Then
					For player2.player=Each player
						If player2\team=1 Then
							player2\sv_givemoney=player2\sv_givemoney+2750
						EndIf
					Next
				EndIf
				
			;12 - Terrorists win - Bombed
			Case 12
				hud_m_add("Target Succesfully Bombed!",3000):e_play(sfx_r_terwin):e_sv_winrow_t=e_sv_winrow_t+1:e_sv_winrow_ct=0
				For item.item=Each item
					If item\typ=100 Then
						For wink=0 To 360 Step 10
							e_add_sprite_smokepuff((item\x*32)+16+Sin(wink)*15,(item\y*32)+16-Cos(wink)*15,Rand(5,15),Rnd(0.4,0.6))
						Next
						e_add_explosion((item\x*32)-16,(item\y*32)-16,300,1,15)
						e_add_explosion((item\x*32)-16,(item\y*32)-16,640,1,30)
						e_sound(sfx_w_c4_explode,item\x*32,item\y*32)
						For amount=0 To Rand(10,15)
							e_add_explosion((item\x*32)+Rand(-300,300),(item\y*32)+Rand(-300,300),Rand(32,100),1,0)
						Next
						e_add_decal(item\x*32,item\y*32,gfx_decals,0,Rnd(0.6,0.95),0,0,0,Rand(15000,25000),Rand(0,360))
						If e_player=e_server Then game_damagewave(item\x*32,item\y*32,300,800,55,-1)
						e_quake#=120.0
						FreeEntity item\h
						Delete item
						Exit
					EndIf
				Next
				If e_player=e_server Then
					For player2.player=Each player
						If player2\team=1 Then
							player2\sv_givemoney=player2\sv_givemoney+2750
						EndIf
					Next
				EndIf
				
				
			;20 - Counter-Terrorists win
			Case 20
				hud_m_add("Counter-Terrorists Win!",3000):e_play(sfx_r_ctwin):e_sv_winrow_ct=e_sv_winrow_ct+1:e_sv_winrow_t=0
				
			;21 - Counter-Terrorists win - VIP escaped
			Case 21
				hud_m_add("The VIP has escaped!",3000):e_play(sfx_r_ctwin):e_sv_winrow_ct=e_sv_winrow_ct+1:e_sv_winrow_t=0
				If e_player=e_server Then
					For player.player=Each player
						If player\vip=1 Then
							player_kill(player\id, 203, 0, 1)
							Exit
						EndIf
					Next
				EndIf
				If e_player=e_server Then
					For player2.player=Each player
						If player2\team=2 Then
							player2\sv_givemoney=player2\sv_givemoney+2750
						EndIf
					Next
				EndIf
				
			;22 - Counter-Terrorists win - Bomb defused
			Case 22
				hud_m_add("The bomb has been defused!",3000):e_play(sfx_r_bombdef):e_sv_winrow_ct=e_sv_winrow_ct+1:e_sv_winrow_t=0
				For item.item=Each item
					If item\typ=100 Then
						FreeEntity item\h
						Delete item
						Exit
					EndIf
				Next
				If e_player=e_server Then
					For player2.player=Each player
						If player2\team=2 Then
							player2\sv_givemoney=player2\sv_givemoney+2750
						EndIf
					Next
				EndIf
				e_sv_bombtimer=0
				
			;23 - Counter-Terrorists win - Hostages rescued
			Case 23	
				hud_m_add("All Hostages have been rescued!",3000):e_play(sfx_r_ctwin):e_sv_winrow_ct=e_sv_winrow_ct+1:e_sv_winrow_t=0
			
			;30 - Round Restart
			Case 30 hud_m_add("Round Restart",3000)
			
			;40 - Game Comencing
			Case 40 hud_m_add("Game Comencing...",3000)
		End Select
	;---------------------------------------------------------Eigentlicher Restart
	Else
	
		;Scores (Client & Server)
		Select mode
			Case 0
			Case 10,11,12,13,14,15,16,17,18,19 e_sv_score_t=e_sv_score_t+1
			Case 20,21,22,23,24,25,26,27,28,29 e_sv_score_ct=e_sv_score_ct+1
			Case 30,40
				e_sv_score_t=0:e_sv_score_ct=0
				e_sv_round=0
				For player.player=Each player
					player\frags=0
					player\deads=0
					For i=0 To 14
						player\sweapon[14]=0
						player\sammo[14]=0
						player\sammoin[14]=0
						player\money$=0
					Next
				Next
		End Select
		
		;Map resetten
		e_map_reset()
		
		;Verteilen von VIP/Bome (Server only!)
		If e_player=e_server Then
			e_sv_playergiven=0
			Local playergive=e_sv_playergive
			Local increased=0
			Local lowest
			Local t=0
			Local ct=0
			e_sv_playergive=-1
			;-------------------------------AS-MAP: VIP
			If map_gametype=1 Then
				For player.player=Each player
					player\vip=0
					player\mission=0
					If player\team=2 Then ct=ct+1
				Next
				;Keinem Geben
				If ct=0 Then
					e_sv_playergive=-1
				;Einem Geben
				ElseIf ct=1 Then
					For player.player=Each player
						If player\team=2 Then
							e_sv_playergive=player\id
							e_sv_playergiven=1
							Exit
						EndIf
					Next
				;Mehrere
				Else
					;Nchstem geben
					increased=0
					For player.player=Each player
						If player\team=2 Then
							If player\id>playergive Then
								e_sv_playergive=player\id
								e_sv_playergiven=1
								increased=1
								Exit
							EndIf
						EndIf
					Next
					;Kein Nchster? -> Erstem geben
					lowest=99999
					If increased=0 Then
						For player.player=Each player
							If player\team=2 Then
								If player\id<lowest Then
									e_sv_playergive=player\id
									e_sv_playergiven=1
									lowest=player\id
								EndIf
							EndIf
						Next
					EndIf
				EndIf
				
			;-------------------------------DE-MAP: Bombe
			ElseIf map_gametype=3 Then
				For player.player=Each player
					If player\slot=7 Then
						player_bestweapon(player\id)
					EndIf
					If player\sweapon[7]=55 Then player\sweapon[7]=0
					player\mission=0
					If player\team=1 Then t=t+1
				Next
				;Keinem Geben
				If t=0 Then
					e_sv_playergive=-1
				;Einem Geben
				ElseIf t=1 Then
					For player.player=Each player
						If player\team=1 Then
							e_sv_playergive=player\id
							e_sv_playergiven=1
							Exit
						EndIf
					Next
				;Mehrere
				Else
					;Nchstem geben
					increased=0
					For player.player=Each player
						If player\team=1 Then
							If player\id>playergive Then
								e_sv_playergive=player\id
								e_sv_playergiven=1
								increased=1
								Exit
							EndIf
						EndIf
					Next
					;Kein Nchster? -> Erstem geben
					lowest=99999
					If increased=0 Then
						For player.player=Each player
							If player\team=1 Then
								If player\id<lowest Then
									e_sv_playergive=player\id
									e_sv_playergiven=1
									lowest=player\id
								EndIf
							EndIf
						Next
					EndIf
				EndIf
			EndIf
		EndIf
		
		
		;Auf Startposition setzen (Server only!)
		If e_player=e_server Then
			For player.player=Each player
				player\x=-32
				player\y=-32
				player\health=0
			Next
			For player.player=Each player
				If player\id=e_sv_playergive Then
					player_start(player\id,0,0,0,1,0,1,1)	;Starten mit Mission
				Else
					player_start(player\id,0,0,0,0,0,1,1)	;Starten ohne Mission
				EndIf
			Next
		EndIf
		
		;Round Session ID
		If e_player=e_server Then
			e_sv_rsession=e_sv_rsession+1
			If e_sv_rsession>255 Then e_sv_rsession=0
		EndIf
		e_sv_round=e_sv_round+1
		
		;Start Sound
		If map_gametype=1 And e_team=2 Then
			e_play(sfx_r_vip)
		Else
			Local sid
			sid=Rand(0,3)
			Select sid
				Case 0 e_play(sfx_r_go)
				Case 1 e_play(sfx_r_letsgo)
				Case 2 e_play(sfx_r_locknload)
				Case 3 e_play(sfx_r_moveout)
			End Select
		EndIf
		
	EndIf
	;Senden
	If send Then
	
		;Pre-Restart
		If timer<>0
			For player.player=Each player
				If player\id<>e_player Then
					udp_iniimp(player\ip,player\port,2)
					udp_w_byte(105)
					udp_w_byte(mode)
					udp_w_int(timer)		
					udp_sendimp()
				EndIf
			Next	
			
		;Restart
		Else
			Local pcount=0
			For player.player=Each player
				If player\team<>0 Then
					pcount=pcount+1
				EndIf
			Next
			For player.player=Each player
				If player\id<>e_player Then
					udp_iniimp(player\ip,player\port,2)
					udp_w_byte(105)
					udp_w_byte(mode)
					udp_w_int(timer)
					udp_w_byte(e_sv_rsession)
					udp_w_int(e_sv_score_t)
					udp_w_int(e_sv_score_ct)
					udp_w_byte(pcount)
					sb=16
					For player2.player=Each player
						If player2\team<>0 Then
							udp_w_byte(player2\id)
							udp_w_int(player2\x)
							udp_w_int(player2\y)
							udp_w_short(player2\dir)
							udp_w_byte(player2\mission)
							udp_w_int(player2\sv_givemoney)
							sb=sb+16
						EndIf
					Next
					udp_sendimp(200)
					udp_sendb(sb+2)
				EndIf
			Next
		EndIf
	EndIf
End Function

;--------------------Game Send Settings
Function game_sendsettings(msg=0)
	If e_player<>e_server Then Return 0
	For player.player=Each player
		If player\id<>e_player Then
			udp_iniimp(player\ip,player\port)
			udp_w_byte(107)
			udp_w_line(e_sv_name$)
			udp_w_byte(e_sv_maxplayers)
			udp_w_byte(e_sv_fow)
			udp_w_byte(e_sv_warmode)
			udp_w_byte(msg)
			udp_sendimp()
			udp_sendb(17)
		EndIf
	Next
	Return 1
End Function