;----------------------------------------UDP

;--------------------UDP initialisieren
Function udp_ini(forceport=0)
	;Standart Connection
	If udp=0 Then
		If forceport<>0 Then
			udp=CreateUDPStream(forceport)
			If udp=0 Then CreateUDPStream()
		Else
			If op_fixedport=0 Then
				udp=CreateUDPStream()
			Else
				udp=CreateUDPStream(op_fixedport)
			EndIf
		EndIf
	EndIf
	;Alternative Connection
	If udp=0 Then
		For i=0 To 50
			If udp=0 Then
				udp=CreateUDPStream()
				If udp<>0 Then Exit
			EndIf
		Next
		If udp Then
			con_add("UDP initialized. Using Port "+UDPStreamPort(udp),0,1)
		Else
			con_add("Error: Can't initialize UDP Connection!",0,1)
			RuntimeError("Can't initialize UDP Connection!")
			Return 0
		EndIf
	Else
		con_add("UDP initialized. Using Port "+UDPStreamPort(udp),0,1)
		Return 1
	EndIf
End Function

;--------------------UDP testen
Function udp_chk(msg=0)
	If udp=0 Then
		con_add("Error: Can't initialize UDP!",0,1)
		If msg Then men_msg("Can't initialize UDP!",2,0)
		Return 1
	Else
		Return 0
	EndIf
End Function

;--------------------UDP subern
Function udp_clear()
	If udp=0 Then
		Return 0
	Else
		While RecvUDPMsg(udp)
			gbytes=ReadAvail(udp)
			For i=1 To gbytes
				ReadByte(udp)
			Next
		Wend
		CloseUDPStream(udp)
		udp=0
		Return 1
	EndIf
End Function

;--------------------Nachrichten Empfangen
Function udp_get()
Local udp_fip,udp_fport,typ,typ2,typ3,val1$,val2$,gbytes
	While RecvUDPMsg(udp)
		gbytes=ReadAvail(udp)
		If gbytes>0 Then
			;Cache Vars: cv1,cv2,cv3, [...]
			;Cache Vars Strings: cs1$,cs2$,cs3$, [...]
			e_getbytes_f=e_getbytes_f+gbytes
			udp_fip=UDPMsgIP(udp)
			udp_fport=UDPMsgPort(udp)
			typ=ReadByte(udp)
			
			;foreign Server
			If e_player<>e_server Then
				If udp_fip<>e_sv_ip Then
					If udp_fport<>e_sv_port Then
						typ=-1
					EndIf
				EndIf
			EndIf
			
			Select typ
				
				;----------ERRORS
				;-1 - foreign Server
				Case -1
					If op_debug Then
						cv1=0
						cv2=ReadByte(udp)
						For player.player=Each player
							If player\ip=udp_fip Then
								If player\port=udp_fport Then
									con_add("Warning: Received and ignored client msg ("+DottedIP(udp_fip)+":"+udp_fport+", "+cv2+")",0,1)
									cv1=1
									Exit
								EndIf
							EndIf
						Next
						If Not cv1 Then con_add("Warning: Received and ignored foreign msg ("+DottedIP(udp_fip)+":"+udp_fport+", "+cv2+")",0,1)
					EndIf
				
				
				;----------GAME PLAYER ACTIONS
				
				;10 - Shoot
				Case 10
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)			;Round Session ID
					If cv2=e_sv_rsession Then
						player_attack(cv1,0)
					EndIf
					
				;11 - Weaponmode
				Case 11
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)			;Weaponmode
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_attack2(cv1,cv2,0)
					EndIf
					
				;12 - Shoot Important
				Case 12
					cv1=ReadByte(udp)			;Round Session ID
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						If cv1=e_sv_rsession Then
							player_attack(player_getid(udp_fip,udp_fport),0)
						EndIf
					EndIf
					
				;13 - Shoot + Hit
				Case 13
					cv1=ReadByte(udp)			;Damaged Count
					For i=0 To 32
						udp_damage(i)=-1
					Next
					For i=1 To cv1
						udp_damage(i)=ReadByte(udp)
					Next
					cv2=ReadByte(udp)			;Weapon
					cv3=ReadByte(udp)			;Weaponmode
					
					cv4=ReadByte(udp)			;Round Session ID
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						If cv4=e_sv_rsession Then
							player_attack(player_getid(udp_fip,udp_fport),0,0)
							player_attack_servercheck(player_getid(udp_fip,udp_fport),cv1,cv2,cv3)
						EndIf
					EndIf
					
				
				;15 - Pos
				Case 15
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadInt(udp)			;X-Pos
					cv3=ReadInt(udp)			;Y-Pos
					cv4=ReadByte(udp)			;Round Session ID
					If cv4=e_sv_rsession Then
						player_pos(cv1,cv2,cv3, 0)
					EndIf
								
				;16 - Direction
				Case 16
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadShort(udp)-32767	;Dir
					player_turn(cv1,cv2,0)
					;Send - Server
					If e_player=e_server Then
						For pl1.player=Each player
							If pl1\id=cv1 Then
								sendx=pl1\x
								sendy=pl1\y
							EndIf
						Next
						For pl2.player=Each player
							If pl2\id<>cv1 And pl2\id<>e_server Then
								If (Abs(pl2\x-sendx)<udp_sx And Abs(pl2\y-sendy)<udp_sy) Then
									WriteByte(udp),16
									WriteByte(udp),cv1
									WriteShort(udp),cv2+32767
									SendUDPMsg(udp, pl2\ip, pl2\port)
									udp_sendb(4)
								EndIf
							EndIf
						Next
					EndIf
					
				;20 - Move
				Case 20
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)-128		;X-Dif
					cv3=ReadByte(udp)-128		;Y-Dif
					player_move_rel(cv1,cv2,cv3,0)
					;Send - Server
					If e_player=e_server Then
						For pl1.player=Each player
							If pl1\id=cv1 Then
								sendx=pl1\x
								sendy=pl1\y
							EndIf
						Next
						For pl2.player=Each player
							If pl2\id<>cv1 And pl2\id<>e_server Then
								If (Abs(pl2\x-sendx)<udp_sx And Abs(pl2\y-sendy)<udp_sy) Then
									WriteByte(udp),20
									WriteByte(udp),cv1
									WriteByte(udp),cv2+128
									WriteByte(udp),cv3+128
									SendUDPMsg(udp, pl2\ip, pl2\port)
									udp_sendb(4)
								EndIf
							EndIf
						Next
					EndIf
				
				;21 - Walk
				Case 21
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)-128		;X-Dif
					cv3=ReadByte(udp)-128		;Y-Dif
					player_move_rel(cv1,cv2,cv3,1)
					;Send - Server
					If e_player=e_server Then
						For pl1.player=Each player
							If pl1\id=cv1 Then
								sendx=pl1\x
								sendy=pl1\y
							EndIf
						Next
						For pl2.player=Each player
							If pl2\id<>cv1 And pl2\id<>e_server Then
								If (Abs(pl2\x-sendx)<udp_sx And Abs(pl2\y-sendy)<udp_sy) Then
									WriteByte(udp),21
									WriteByte(udp),cv1
									WriteByte(udp),cv2+128
									WriteByte(udp),cv3+128
									SendUDPMsg(udp, pl2\ip, pl2\port)
									udp_sendb(4)
								EndIf
							EndIf
						Next
					EndIf
					
				;22 - Move + Direction
				Case 22
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)-128		;X-Dif
					cv3=ReadByte(udp)-128		;Y-Dif
					cv4=ReadShort(udp)-32767	;Dir
					player_move_rel(cv1,cv2,cv3,0)
					player_turn(cv1,cv4,0)
					;Send - Server
					If e_player=e_server Then
						For pl1.player=Each player
							If pl1\id=cv1 Then
								sendx=pl1\x
								sendy=pl1\y
							EndIf
						Next
						For pl2.player=Each player
							If pl2\id<>cv1 And pl2\id<>e_server Then
								If (Abs(pl2\x-sendx)<udp_sx And Abs(pl2\y-sendy)<udp_sy) Then
									WriteByte(udp),22
									WriteByte(udp),cv1
									WriteByte(udp),cv2+128
									WriteByte(udp),cv3+128
									WriteShort(udp),cv4+32767
									SendUDPMsg(udp, pl2\ip, pl2\port)
									udp_sendb(6)
								EndIf
							EndIf
						Next
					EndIf
				
				;23 - Walk + Direction
				Case 23
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)-128		;X-Dif
					cv3=ReadByte(udp)-128		;Y-Dif
					cv4=ReadShort(udp)-32767	;Dir
					player_move_rel(cv1,cv2,cv3,1)
					player_turn(cv1,cv4,0)
					;Send - Server
					If e_player=e_server Then
						For pl1.player=Each player
							If pl1\id=cv1 Then
								sendx=pl1\x
								sendy=pl1\y
							EndIf
						Next
						For pl2.player=Each player
							If pl2\id<>cv1 And pl2\id<>e_server Then
								If (Abs(pl2\x-sendx)<udp_sx And Abs(pl2\y-sendy)<udp_sy) Then
									WriteByte(udp),23
									WriteByte(udp),cv1
									WriteByte(udp),cv2+128
									WriteByte(udp),cv3+128
									WriteShort(udp),cv4+32767
									SendUDPMsg(udp, pl2\ip, pl2\port)
									udp_sendb(6)
								EndIf
							EndIf
						Next
					EndIf
				
				;30 - Select Weapon
				Case 30
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)			;
					cv3=ReadByte(udp)			;
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_weapon(cv1,cv2,cv3,0)
					EndIf
					
					
				;31 - Drop
				Case 31
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)			;Slot
					cv3=ReadByte(udp)			;Item Typ
					cv4=ReadInt(udp)			;Ammo
					cv5=ReadInt(udp)			;Ammoin
					cv6=ReadInt(udp)			;X
					cv7=ReadInt(udp)			;Y
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_drop(cv1,cv2,cv3,cv4,cv5,cv6,cv7,0)
					EndIf
				
				;32 - Buy
				Case 32
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)			;Item
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_buy(cv1,cv2,0)
					EndIf
				
				;33 - Action
				Case 33
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)			;Action
					cv3=ReadByte(udp)			;Mode
					cv4=ReadByte(udp)			;Round Session ID
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						If cv4=e_sv_rsession Then
							If cv2=1 Then
								player_reload(cv1,cv3,0)
							Else
								player_action(cv1,cv2,cv3,0)
							EndIf
						EndIf
					EndIf
					
				;34 - Collect
				Case 34
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)			;Item Typ
					cv3=ReadInt(udp)			;X
					cv4=ReadInt(udp)			;Y
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						;Server - Collect Check
						If e_player=e_server Then
							player_collect(cv1,cv2,cv3,cv4,1)
						;Client - Collect	
						Else
							player_collect(cv1,cv2,cv3,cv4,2)
						EndIf
					EndIf
					
				;40 - Hurt
				Case 40
					cv1=ReadByte(udp)			;ID
					cv2=ReadByte(udp)			;Hurter
					cv3=ReadByte(udp)			;Power
					cv4=ReadByte(udp)			;Weapon
					cv5=ReadByte(udp)			;Armor
					cv6=ReadByte(udp)			;Round Session ID
					If cv6=e_sv_rsession Then
						player_hurt(cv1,cv2,cv3,cv4,0,cv5)
					EndIf
				
				;41 - Kill
				Case 41
					cv1=ReadByte(udp)			;
					cv2=ReadByte(udp)			;
					cv3=ReadByte(udp)			;
					cv4=ReadByte(udp)			;Round Session ID
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						If cv4=e_sv_rsession Then
							player_kill(cv1,cv2,cv3,0)
						EndIf
					EndIf
					
				;42 - Health
				Case 42
					cv1=ReadByte(udp)			;ID
					cv2=ReadByte(udp)			;Health
					cv3=ReadByte(udp)			;Armor
					cv4=ReadByte(udp)			;Round Session ID
					If cv4=e_sv_rsession Then
						For player.player=Each player
							If player\id=cv1 Then
								player\health=cv2
								player\armor=cv3
							EndIf
						Next
					EndIf
					
				;50 - Grenade
				Case 50
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)			;Grenade ID
					cv3=ReadInt(udp)			;X
					cv4=ReadInt(udp)			;Y
					cv5=ReadInt(udp)			;Dir
					cv6=ReadByte(udp)			;Typ
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_gren(cv1,cv2,cv3,cv4,cv5,cv6,0)
					EndIf
					
				
				;51 - Grenade Explode
				Case 51
					cv1=ReadByte(udp)			;Grenade ID
					cv2=ReadInt(udp)			;X
					cv3=ReadInt(udp)			;Y
					cv4=ReadByte(udp)			;Typ
					cv5=ReadByte(udp)			;Owner
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						game_gren_explode(cv1,cv2,cv3,cv4,cv5,0)
					EndIf
					
				
				;60 - Hostage Data
				Case 60
					cv1=ReadByte(udp)			;
					cv2=ReadInt(udp)			;
					cv3=ReadInt(udp)			;
					cv4=ReadInt(udp)			;
					cv5=ReadByte(udp)			;Round Session ID
					If cv5=e_sv_rsession Then
						game_hostage_data(cv1,cv2,cv3,cv4,0)
					EndIf
				
				;61 - Hostage Damage
				Case 61
					cv1=ReadByte(udp)			;
					cv2=ReadByte(udp)			;
					cv3=ReadByte(udp)			;
					cv4=ReadByte(udp)			;
					cv5=ReadByte(udp)			;Round Session ID
					If cv5=e_sv_rsession Then
						game_hostage_hurt(cv1,cv2,cv3,cv4,0)
					EndIf
				
				;62 - Hostage Kill
				Case 62
					cv1=ReadByte(udp)			;
					cv2=ReadByte(udp)			;
					cv3=ReadByte(udp)			;
					cv4=ReadByte(udp)			;Round Session ID
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						If cv4=e_sv_rsession Then
							game_hostage_kill(cv1,cv2,cv3,0)
						EndIf
					EndIf
					
				;63 - Hostage Rescue
				Case 63
					cv1=ReadByte(udp)			;
					cv2=ReadByte(udp)			;Round Session ID
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						If cv2=e_sv_rsession Then
							game_hostage_rescue(cv1,0)
						EndIf
					EndIf
				
				;90 - Spraylogo
				Case 90
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadInt(udp)			;Logo X
					cv3=ReadInt(udp)			;Logo Y
					cs1$=ReadLine(udp)			;Logofile
					cv4=ReadByte(udp)			;
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_spray(cv1,cv2,cv3,cs1$,cv4,0)
					EndIf
					
				;91 - Say/Sayteam/Servermsg
				Case 91
					cv1=ReadByte(udp)			;Say (1) / Sayteam (2) / Servermsg (3)
					cv2=ReadByte(udp)			;Sender Player ID
					cs1$=ReadLine(udp)			;Chat Message
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						Select cv1
							Case 1 player_say(cv2,cs1$,0)
							Case 2 player_sayteam(cv2,cs1$,0)
							Case 3 hud_ml_add("",0,"* "+cs1$,1)
						End Select
					EndIf
					
					
				;92 - Radio
				Case 92
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)			;Radio
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_radio(cv1,cv2,0)
					EndIf
					
				;93 - Nick
				Case 93
					cv1=ReadByte(udp)			;Player ID
					cs1$=ReadLine(udp)			;New Nick
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_name(cv1,cs1$,0)
					EndIf
					
				;94 - Player Data Small
				Case 94
					cv1=ReadByte(udp)			;Player ID
					cs1$=ReadLine(udp)			;Nick
					cv2=ReadShort(udp)			;Frags
					cv3=ReadShort(udp)			;Deads
					cv4=ReadByte(udp)			;Admin
					;For player.player=Each player
					;	If player\id=cv1 Then
					;		player\name$=cs1$
					;		player\frags=cv2-32767
					;		player\deads=cv3-32767
					;		player\gameadmin=cv4
					;		Exit
					;	EndIf
					;Next
					
				;230 - Cheat
				Case 230
					cv1=ReadByte(udp)			;0
					cv2=ReadByte(udp)			;Player
					cv3=ReadShort(udp)			;Health
					cv4=ReadShort(udp)			;Armor
					cv5=ReadShort(udp)			;Ammo
					;Cheat detected?
					For player.player=Each player
						If player\id=cv2 Then
							If player\forcedeath=0 Then
								If cv3>100 Then ch_msg$="High Health":DebugLog ch_msg$:player_leave(cv2,4,1)
								If cv4>200 Then ch_msg$="High Armor":DebugLog ch_msg$:player_leave(cv2,4,1)
								If cv5>255 Then ch_msg$="High Ammo":DebugLog ch_msg$:player_leave(cv2,4,1)
							EndIf
						EndIf
					Next
				
				
				;----------GAME BASIC SYSTEM
							
				;100 - Player Data
				Case 100
					player_set()
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					udp_okimpsend(cok,udp_fip,udp_fport)
								
				;101 - Player Connect
				Case 101
					cs1$=ReadLine(udp)			;Player Name
					cv1=ReadInt(udp)			;
					cv2=ReadInt(udp)			;
					cv3=ReadByte(udp)			;
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_add(cs1$, 0, cv1, cv2, cv3)
					EndIf
					
				;102 - Player Team
				Case 102
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)			;Team ID
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_team(cv1, cv2, 0)
					EndIf
					
				;103 - Player Look
				Case 103
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadByte(udp)			;Look ID
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_look(cv1, cv2, 0)
						player_ini(cv1)
						;Server - Player starten
						If e_player=e_server Then
							If e_rt_m>=4 Then
								;Nur in den ersten 15 Sekunden joinen erlauben
								If e_rt_m=5 Or e_rt_s>=15 Then
									;Nur wenn er noch nicht lebte
									For player.player=Each player
										If player\id=cv1 Then
											If player\roundlived<>e_sv_rsession
												player_start(cv1)
											EndIf
											Exit
										EndIf
									Next
								EndIf
							EndIf
						EndIf
					EndIf
					
				;104 - Player Start
				Case 104
					cv1=ReadByte(udp)			;Player ID
					cv2=ReadInt(udp)			;Player X
					cv3=ReadInt(udp)			;Player Y
					cv4=ReadShort(udp)			;Player Dir
					cv5=ReadByte(udp)			;Player Mission
					cv6=ReadInt(udp)			;Player Money
					cv7=ReadByte(udp)			;Round Session ID
					e_sv_rsession=cv7
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						player_start(cv1,cv2,cv3,cv4,cv5,cv6,0)
					EndIf
					
				;105 - Game Startround
				Case 105
					cv1=ReadByte(udp)			;Restart Mode
					cv2=ReadInt(udp)			;Restart Timer
					;Pre-Restart
					If cv2<>0 Then
						cok=ReadShort(udp)		;Sichere Nachricht empfangen
						If udp_okimpsend(cok,udp_fip,udp_fport) Then
							game_startround(cv1,cv2,0)
						EndIf
					;Restart
					Else
						If ms-e_lastrr>4500 Then
							game_startround(cv1,cv2,0)
							e_sv_rsession=ReadByte(udp)
							e_sv_score_t=ReadInt(udp)
							e_sv_score_ct=ReadInt(udp)
							cv3=ReadByte(udp)		;Player Start Data Count
							For cv11=1 To cv3
								cv4=ReadByte(udp)	;Player ID
								cv5=ReadInt(udp)	;Player X
								cv6=ReadInt(udp)	;Player Y
								cv7=ReadShort(udp)	;Player Dir
								cv8=ReadByte(udp)	;Player Mission
								cv9=ReadInt(udp)	;Player Money
								player_start(cv4,cv5,cv6,cv7,cv8,cv9,0)
							Next
							cok=ReadShort(udp)		;Sichere Nachricht empfangen
							udp_okimpsend(cok,udp_fip,udp_fport)
							e_lastrr=ms
						EndIf
					EndIf
					
				;106 - Mapchange
				Case 106
					cs1$=ReadLine(udp)			;Map
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						udp_mapchange(cs1$)
					EndIf
					
				;107 - Server Settings
				Case 107
					cs1$=ReadLine(udp)			;Name
					cv1=ReadByte(udp)			;MaxPlayers
					cv2=ReadByte(udp)			;Fog of War
					cv3=ReadByte(udp)			;War Mode
					cv4=ReadByte(udp)			;Message
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						e_sv_name$=cs1$
						e_sv_maxplayers=cv1
						e_sv_fow=cv2:ch_fow=e_sv_fow*ch_fak:ch_fow2=e_sv_fow*ch_fak2
						e_sv_warmode=cv3:ch_warmode=e_sv_warmode*ch_fak
						Select cv4
							Case 1 hud_m_add("Server changed Max Players to "+cv1)
							Case 2 hud_m_add("Server changed Fog of War to "+cv2)
							Case 3 hud_m_add("Server changed War Mode to "+cv3)
						End Select
					EndIf
				
				;108 - Remote Server Execute
				Case 108
					cs1$=ReadLine(udp)			;PW
					cs2$=ReadLine(udp)			;Script
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						con_add("Incoming remote commands ("+cs1$+", "+cs2$+")",0,1)
						If e_player=e_server Then
							If e_sv_remotepw$<>"" Then
								If cs1$=e_sv_remotepw$ Then
									parse(cs2$)
								EndIf
							EndIf
						EndIf
					EndIf
				

				;110 - Break Entity
				Case 110
					cv1=ReadInt(udp)			;Y
					cv2=ReadInt(udp)			;Y
					cv3=ReadByte(udp)			;Round Session ID
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						If e_sv_rsession=cv3 Then
							e_kill_breakable(cv1,cv2,1,0)
						EndIf
					EndIf
					
				;150 - File request
				Case 150
					
				
				;151 - File initiale
				Case 151
					
				
				;152 - File
				Case 152
				
				;155 - File Data
				Case 155
					cv1=ReadByte(udp)			;File ID
					cv2=ReadInt(udp)			;Paket ID
					cv3=ReadByte(udp)
					For i=1 To 512
						ReadByte(udp)
					Next
					
				
					
				
				;----------SERVERLIST/JOIN MESSAGES
				
				;250
				Case 250
					typ2=ReadByte(udp)
					Select typ2
					;250:0 - Info Request
					Case 0
						If e_server=e_player Then
							WriteByte(udp),250
							WriteByte(udp),1
							WriteLine(udp),e_sv_name$
							If Len(e_sv_pw$)>0 Then
								WriteByte(udp),1
							Else
								WriteByte(udp),0
							EndIf
							WriteLine(udp),map_name$
							WriteByte(udp),player_count(0)
							WriteByte(udp),e_sv_maxplayers
							WriteByte(udp),e_sv_fow
							WriteByte(udp),e_sv_warmode
							SendUDPMsg(udp, udp_fip, udp_fport)
							udp_sendb(27)
							If op_debug Then con_add("Server Info Request from "+DottedIP(udp_fip)+":"+udp_fport,0,1)
						EndIf
					;250:2 - Join Request
					Case 2
						If e_server=e_player Then
							val1$=ReadLine(udp)
							val2$=ReadLine(udp)
							ph=0
							;Eigene Server IP + Port laden:
							For player.player=Each player
								If player\id=e_player Then ph=1:Exit
							Next
							If ph=1 Then
								player\ip=ReadInt(udp)
								player\port=ReadInt(udp)
							Else
								ReadInt(udp)
								ReadInt(udp)
								con_add("Error: Can't find server data")
							EndIf
							;Antwort senden
							WriteByte(udp),250
							WriteByte(udp),3
							;Ban?
							Local ban=0
							For sv_ban.sv_ban=Each sv_ban
								If sv_ban\ip=udp_fip Then
									ban=1
									Exit
								EndIf
							Next
							;Joinen erlauben?
							If (val1$=e_sv_pw$ And player_count(0)<e_sv_maxplayers) And ban=0 Then
								;1 - Ja!
								typ3=player_add(val2$, 0, udp_fip, udp_fport)
								WriteByte(udp),1						;OK Byte
								WriteByte(udp),typ3						;New Player ID
								WriteInt(udp),udp_fip					;New Player IP
								WriteInt(udp),udp_fport					;New Player Port
								WriteLine(udp),version$					;Server Game Version
								WriteLine(udp),map_code$				;Server Map Code
								WriteLine(udp),map_name$				;Server Map Name
								WriteByte(udp),0						;Server ID
								WriteLine(udp),e_sv_name$				;Server Name
								WriteByte(udp),e_sv_maxplayers			;Server Maxplayers
								WriteByte(udp),e_sv_fow					;Server Fog of War
								WriteByte(udp),e_sv_warmode				;Server Warmode
								WriteByte(udp),e_rt_s					;Server RoundTime Sec
								WriteByte(udp),e_rt_m					;Server RountTime Min
								WriteShort(udp),e_sv_score_t			;Server Score T
								WriteShort(udp),e_sv_score_ct			;Server Score CT
								WriteByte(udp),e_sv_winrow_t			;Server Winrow T
								WriteByte(udp),e_sv_winrow_ct			;Server Winrow CT
								WriteInt(udp),e_sv_bombtimer			;Server Bombtimer
								WriteByte(udp),e_sv_rsession			;Server Round Session
								SendUDPMsg(udp, udp_fip, udp_fport)		
							Else
								;2 - Nein! Fehler: PW
								If val1$<>e_sv_pw$ Then
									WriteByte(udp),2
									SendUDPMsg(udp, udp_fip, udp_fport)
									If op_debug Then con_add(val2$+" ("+DottedIP(udp_fip)+":"+udp_fport+") can't join: Invalid Server Password ("+val1$+")",0,0)
								;3 - Nein! Fehler: Full
								ElseIf player_count(0)>=e_sv_maxplayers Then
									WriteByte(udp),3
									SendUDPMsg(udp, udp_fip, udp_fport)
									If op_debug Then con_add(val2$+" ("+DottedIP(udp_fip)+":"+udp_fport+") can't join: Server is full",0,0)
								;4 - Nein! Fehler: Ban
								ElseIf ban=1 Then
									WriteByte(udp),4
									SendUDPMsg(udp, udp_fip, udp_fport)
									If op_debug Then con_add(val2$+" ("+DottedIP(udp_fip)+":"+udp_fport+") can't join: Banned",0,0)
								EndIf
							EndIf
						EndIf
					;250:4 - Joined
					Case 4
						val1$=ReadLine(udp)
						typ3=ReadByte(udp)
						con_add(val1$+" joined!",0,1)
						For player.player = Each player
							If player\id <> typ3
								;Daten der Clients an den neuen Client senden
								udp_iniimp(udp_fip, udp_fport)
								udp_w_byte(100)
								udp_w_byte(player\id)
								udp_w_line(player\name$)
								udp_w_byte(player\team)
								udp_w_byte(player\look)
								udp_w_byte(player\vip)
								udp_w_int(player\ip)
								udp_w_int(player\port)
								udp_w_byte(player\health)
								udp_w_int(player\x)
								udp_w_int(player\y)
								udp_w_short((player\dir Mod 360))
								udp_w_short(player\frags+32767)
								udp_w_short(player\deads+32767)
								udp_w_byte(player\sweapon[7])
								udp_w_byte(player\sweapon[8])
								udp_w_byte(player\gameadmin)
								udp_sendimp()
								player_weapon(player\id,player\slot,player\sweapon[player\slot],1)
								If player\id <> e_player Then
									;Daten von neuem Client an die Clients senden
									udp_iniimp(player\ip, player\port)
									udp_w_byte(101)
									udp_w_line(val1$)
									udp_w_int(udp_fip)
									udp_w_int(udp_fport)
									udp_w_byte(typ3)
									udp_sendimp()
								EndIf
							EndIf
						Next
						;Items an den neuen Client senden
						For item.item=Each item
							udp_iniimp(udp_fip, udp_fport)
							udp_w_byte(250)
							udp_w_byte(6)
							udp_w_byte(item\typ)
							udp_w_int(item\ammo)
							udp_w_int(item\ammoin)
							udp_w_int(item\x)
							udp_w_int(item\y)
							udp_w_byte(e_sv_rsession)
							udp_sendimp()
						Next
						;Broken breakable Entities an den neuen Client senden
						For entity.entity=Each entity
							If entity\typ=25
								If entity\value_int[9]=1 Then
									udp_iniimp(udp_fip, udp_fport)
									udp_w_byte(250)
									udp_w_byte(7)
									udp_w_int(entity\x)
									udp_w_int(entity\y)
									udp_w_byte(e_sv_rsession)
									udp_sendimp()
								EndIf
							EndIf
						Next
						game_roundend()
					;250:5 - Not Joined
					Case 5
						val1$=Int(ReadByte(udp))
						If (val1$<>0) Then
							For player.player=Each player
								If player\id=Int(val1$) Then
									If op_debug Then hud_ol_add(player\name$+" failed to connect (version/map error)")
									Delete player
									Exit
								EndIf
							Next
						Else
							con_add("Internal error: tried to remove host (player #0)",0,1)
						EndIf
					;250:6 - Item Data
					Case 6
						;con_add("got item!!11",0,1)
						cv1=ReadByte(udp)			;Item Typ
						cv2=ReadInt(udp)			;Ammo
						cv3=ReadInt(udp)			;Ammoin
						cv4=ReadInt(udp)			;X
						cv5=ReadInt(udp)			;Y
						cv6=ReadByte(udp)			;Round Session ID
						cok=ReadShort(udp)			;Sichere Nachricht empfangen
						If udp_okimpsend(cok,udp_fip,udp_fport) Then
							;con_add("setup item!",0,1)
							e_setup_item(cv1,cv4,cv5,cv2,cv3)
						EndIf
					;250:7 - Broken
					Case 7
						cv1=ReadInt(udp)			;X
						cv2=ReadInt(udp)			;Y
						cv3=ReadByte(udp)			;Round Session ID
						cok=ReadShort(udp)			;Sichere Nachricht empfangen
						If udp_okimpsend(cok,udp_fip,udp_fport) Then
							If cv3=e_sv_rsession Then
								e_kill_breakable(cv1,cv2,0,0)
							EndIf
						EndIf
					
					End Select
				
				
				;251 - Ping
				Case 251
					;Server - Ping Antwort senden und Lastping fr Pingtimeout setzen
					If e_player=e_server Then
						WriteByte(udp),251
						SendUDPMsg(udp, udp_fip, udp_fport)
						udp_sendb(1)
						For player.player=Each player
							If player\ip=udp_fip And player\port=udp_fport Then
								player\sv_lastping=ms
								Exit
							EndIf
						Next
					Else
					;Client - Ping Antwort empfangen
						If e_pingtimer<>0 Then
							For player.player=Each player
								If player\id=e_player Then
									player\ping=(ms-e_pingtimer)-udp_pingfake
									If player\ping<0 Then player\ping=0
									e_pingtimer=0
									e_ping=player\ping
									e_pinglastanswer=ms
									Exit
								EndIf
							Next
							;Eigenen Ping an alle weiterleiten
							For player.player=Each player
								If player\id<>e_player Then
									WriteByte udp, 253
									WriteByte udp, e_player
									WriteInt udp, e_ping
									SendUDPMsg(udp, player\ip, player\port)
									udp_sendb(6)
								EndIf
							Next
						EndIf
					EndIf
				
				;252 - Client/Server Leave
				Case 252 
					cs1=ReadByte(udp)			;Leave Mode
					If cs1<>3 Then				;
						cs2=ReadByte(udp)		;ID
					Else						;
						cs2=0					;ID = 0, Serverleave
					EndIf						;
					cok=ReadShort(udp)			;Sichere Nachricht empfangen
					If udp_okimpsend(cok,udp_fip,udp_fport) Then
						ch_msg$="Server forced"
						player_leave(cs2,cs1,0)
					EndIf
					
				;253 - Ping Data
				Case 253
					cs1=ReadByte(udp)
					cs2=ReadInt(udp)
					For player.player=Each player
						If player\id=cs1 Then
							player\ping=cs2
							Exit
						EndIf
					Next
					
				;254 - Peer 2 Peer Ping
				;Case 254
				;	cv1=ReadByte(udp)			;Mode
				;	cok=ReadShort(udp)			;Sichere Nachricht empfangen
				;	If udp_okimpsend(cok,udp_fip,udp_fport) Then
				;		If cv1=0 Then
				;			;Antwort senden
				;			udp_iniimp(udp_fip,udp_fport)
				;			udp_w_byte(254)
				;			udp_w_byte(1)
				;			udp_sendimp()
				;			udp_sendb(4)
				;		Else
				;			;Antwort annehmen
				;			For player.player=Each player
				;				If player\ip=udp_fip Then
				;					If player\port=udp_fport Then
				;						player\udp_pinged=1
				;						Exit
				;					EndIf
				;				EndIf
				;			Next
				;		EndIf
				;	EndIf
					
				;255 - Message ok
				Case 255
					cs1=ReadShort(udp)
					udp_freeimp(cs1)
			
				;----------DEFAULT
				Default
					If op_debug Then con_add("Warning: Unexpected Message ID @ InGame ("+typ+")",0,0)
					
			End Select
			
		EndIf
	Wend
End Function


;--------------------Nachrichten Empfangen bei Serverliste
Function udp_get_serverlist()
	Local udp_fip,udp_fport,typ,i
	If udp=0 Then Return 0
	While RecvUDPMsg(udp)
		If ReadAvail(udp) Then
			udp_fip=UDPMsgIP(udp)
			udp_fport=UDPMsgPort(udp)
			typ=ReadByte(udp)
			Select typ
			
				;250
				Case 250
					If ReadByte(udp)=1 Then
						For serv.serv = Each serv
							If serv\ip=udp_fip
								serv\name$=ReadLine(udp)
								serv\pw=ReadByte(udp)
								serv\map$=ReadLine(udp)
								serv\players=ReadByte(udp)
								serv\playersmax=ReadByte(udp)
								serv\fow=ReadByte(udp)
								serv\war=ReadByte(udp)
								serv\ping=ms-serv\cont
								Exit
							EndIf
						Next
					EndIf
									
				;251
				Case 251
					For serv.serv = Each serv
						If serv\ip=udp_fip
							serv\ping=ms-serv\cont
							Exit
						EndIf
					Next
					
				
				;Default
				Default
					If op_debug Then con_add("Warning: Unexpected Message ID @ Serverlist ("+typ+")",0,0)
			
			End Select
		EndIf
	Wend
End Function

;--------------------Joinen
Function udp_join(ip,port,pw$,jstr$="")
	load_screen("Connecting ...")
	Local msl,dot,url
	Local udp_fip,udp_fport,typ,i,val$
	Local own_id,own_ip,own_port
	Local sversion$,smapcode$
	;Nicht dedicated!
	e_dedicated=0
	
	;Joinstring (jstr$) zerlegen, falls bergeben
	If jstr$<>"" Then
		;Ist Joinstring eine URL?
		For i=1 To Len(jstr$)
			If Asc(Mid(jstr$,i,1))>58 Then
				url=1
				Exit
			EndIf
		Next
		
		;Per URL:Port Connecten
		If url Then
			If Instr(jstr$,":") Then
				dot=Instr(jstr$,":")
				hipc=CountHostIPs(Left(jstr$,dot-1))
				If hipc Then ip=HostIP(hipc)
				port=Mid(jstr$,dot+1)
			Else
				hipc=CountHostIPs(jstr$)
				If hipc Then ip=HostIP(hipc)
				port=36963
			EndIf
			
		;Per IP:Port Connecten
		Else
			If Instr(jstr$,":") Then
				dot=Instr(jstr$,":")
				ip=udp_int(Left(jstr$,dot-1))
				port=Mid(jstr$,dot+1)
			Else
				ip=udp_int(jstr$)
				port=36963
			EndIf
		EndIf
	EndIf
	
	;Join Request absenden
	If Len(op_nick$)>25 Then op_nick$=Left(op_nick$,25)
	udp_ini()
	If udp_chk() Then Return 0
	WriteByte(udp),250
	WriteByte(udp),2
	WriteLine(udp),pw$
	WriteLine(udp),op_nick$
	WriteInt(udp),ip
	WriteInt(udp),port
	SendUDPMsg(udp,ip,port)
	
	con_add("Connecting to "+DottedIP(ip)+":"+port,0,1)
	
	;Keine Player ID
	e_player=-1
	
	;Auf Antwort warten (5 Sekunden lang)
	msl=MilliSecs()
	While MilliSecs()-msl<5000
		While RecvUDPMsg(udp)
			If ReadAvail(udp) Then
				udp_fip=UDPMsgIP(udp)
				udp_fport=UDPMsgPort(udp)
				typ=ReadByte(udp)
				Select typ
				
					;250
					Case 250
						If ReadByte(udp)=3 Then
							i=ReadByte(udp)
							Select i
								;4 - Fehler: Ban
								Case 4
									men_msg("Server has banned you",2)
									Return 0
								;3 - Fehler: Full
								Case 3
									men_msg("Server is full",2)
									Return 0
								;2 - Fehler: PW
								Case 2
									men_msg("Invalid Server Password",2)
									Return 0
								;1 - OK.. ?
								Case 1
									;Eigene Daten
									own_id=ReadByte(udp)
									own_ip=ReadInt(udp)
									own_port=ReadInt(udp)
									
									;Lastping setzen um sofortigen Pingtimeout zu vermeiden
									e_pinglastanswer=MilliSecs()
									
									;Version ok?
									sversion$=ReadLine(udp)
									If sversion$<>version$ Then
										men_msg("Version mismatch! You need "+sversion$,2)
										WriteByte(udp),250
										WriteByte(udp),5
										WriteByte(udp),own_id
										SendUDPMsg(udp,e_sv_ip,e_sv_port)
										Return 0
									EndIf
									
									;Client Game initialisieren?
									smapcode$=ReadLine(udp)
									map_name$=ReadLine(udp)
									serverid=ReadByte(udp)
									cache_e_sv_name$=ReadLine(udp)
									cache_e_sv_maxplayers=ReadByte(udp)
									cache_e_sv_fow=ReadByte(udp)
									cache_e_sv_warmode=ReadByte(udp)
									cache_e_rt_s=ReadByte(udp)
									cache_e_rt_m=ReadByte(udp)
									cache_e_sv_score_t=ReadShort(udp)
									cache_e_sv_score_ct=ReadShort(udp)
									cache_e_sv_winrow_t=ReadByte(udp)
									cache_e_sv_winrow_ct=ReadByte(udp)
									cache_e_sv_bombtimer=ReadInt(udp)
									cache_e_sv_rsession=ReadByte(udp)
									If game_client_ini(map_name$,smapcode$,own_id,serverid, ip, port) Then
										;Ja!
										;Items lschen
										For item.item=Each item
											FreeEntity item\h
											Delete item
										Next
										e_sv_name$=cache_e_sv_name$
										e_sv_maxplayers=cache_e_sv_maxplayers
										e_sv_fow=cache_e_sv_fow:ch_fow=e_sv_fow*ch_fak:ch_fow2=e_sv_fow*ch_fak2
										e_sv_warmode=cache_e_sv_warmode:ch_warmode=e_sv_warmode*ch_fak
										e_rt_s=cache_e_rt_s
										e_rt_m=cache_e_rt_m
										e_sv_score_t=cache_e_sv_score_t
										e_sv_score_ct=cache_e_sv_score_ct
										e_sv_winrow_t=cache_e_sv_winrow_t								
										e_sv_winrow_ct=cache_e_sv_winrow_ct
										e_sv_bombtimer=cache_e_sv_bombtimer
										e_sv_rsession=cache_e_sv_rsession
										e_sv_pw$=pw$
										e_player=player_add(op_nick$,0,own_ip,own_port,own_id)
										;Lastping setzen um sofortigen Pingtimeout zu vermeiden
										e_pinglastanswer=MilliSecs()
										Return 1
									Else
										;Nein
										Return 0
									EndIf
								Default
							End Select	
						EndIf
						
					;Default
					Default
						If op_debug Then con_add("Warning: Unexpected Message ID @ Join Process ("+typ+")",0,0)
				End Select
			EndIf
		Wend	
	Wend
	men_msg("Ping Timeout",2)
	Return 0
End Function


;--------------------Mapchange
Function udp_mapchange(map$)
	load_screen("Loading")
	Local cache_ip=e_sv_ip
	Local cache_port=e_sv_port
	Local cache_pw$=e_sv_pw$
	con_add("",0,0)
	con_add("----- Mapchange",0,0)
	con_add("Address: "+DottedIP(cache_ip)+":"+cache_port,0,0)
	con_add("Map: "+map$,0,0)
	con_add("",0,1)
	e_cls()
	Delay 3000
	load_screen("Initialing...")
	Delay 500
	FlushKeys()
	men_dojob=1
	men_dojob_join$=DottedIP(cache_ip)+":"+cache_port
	men_dojob_pw$=cache_pw$
	leave=1
End Function



;--------------------IP in Integer umwandeln
Function udp_int(stringip$)
	Local break1,break2,break3,add1,add2,add3,add4,ipreturn
	break1 = Instr(stringip$,".")
	break2 = Instr(stringip$,".",break1+1)
	break3 = Instr(stringip$,".",break2+1)
	add1 = Mid(stringip$,1,break1-1)
	add2 = Mid(stringip$,break1+1,break2-1)
	add3 = Mid(stringip$,break2+1,break3-1)
	add4 = Mid(stringip$,break3+1)
	ipreturn=(add1 Shl 24) + (add2 Shl 16) + (add3 Shl 8) + add4
	Return ipreturn
End Function



;----------------------------------------System fr wichtige (imp[ortant]) Daten Pakete


;--------------------Neues Wichtige Daten Paket initialisieren
Function udp_iniimp(targetip,targetport,maxfails=5)
	;ID ermitteln
	udp_stid=udp_stid+1
	If udp_stid>65535 Then udp_stid=0
	;Paket Daten speichern
	udp_data_h.udp_data_h=New udp_data_h
	udp_data_h\id=udp_stid
	udp_data_h\targetip=targetip
	udp_data_h\targetport=targetport
	udp_data_h\maxfails=maxfails
	udp_imp=udp_stid
End Function

;--------------------Wichtiges Daten Paket senden
Function udp_sendimp(adddelay=0)
	;Letzten Wichtigen Daten auswhlen
	udp_data_h.udp_data_h=Last udp_data_h
	;Imp-ID schreiben, Paket senden und Zeitpunkt des Sendens abspeichern
	WriteShort (udp,udp_data_h\id)
	SendUDPMsg(udp, udp_data_h\targetip, udp_data_h\targetport)
	udp_data_h\sended=ms+adddelay
End Function

;--------------------Wichtiges Daten Paket lschen
Function udp_freeimp(id)
	For udp_data_h.udp_data_h=Each udp_data_h
		If udp_data_h\id=id Then
			Delete udp_data_h
			Exit
		EndIf
	Next
	For udp_data.udp_data=Each udp_data
		If udp_data\id=id Then
			Delete udp_data
		EndIf
	Next
End Function

;--------------------Wichtige Daten Pakete erneut senden wenn nach Resend Timer kein OK gekommen ist
Function udp_resendimps()
	udp_stc=0
	If e_bot=1 Then
		;Bei Bot Game Daten einfach lschen
		For udp_data_h.udp_data_h=Each udp_data_h
			Delete udp_data_h
		Next
		For udp_data.udp_data=Each udp_data
			Delete udp_data
		Next
		For udp_getblock.udp_getblock=Each udp_getblock
			Delete udp_getblock
		Next
	Else
		;Data Resends
		For udp_data_h.udp_data_h=Each udp_data_h
			udp_stc=udp_stc+1
			;Resend Time vorbei? -> erneut senden
			If ms-udp_data_h\sended>=udp_impresend Then
				;Alle Daten der Message senden
				bs=0
				For udp_data.udp_data=Each udp_data
					If udp_data\id=udp_data_h\id Then
						Select udp_data\typ
							Case 0 WriteByte(udp,Int(udp_data\dat$)):bs=bs+1
							Case 1 WriteShort(udp,Int(udp_data\dat$)):bs=bs+2
							Case 2 WriteInt(udp,Int(udp_data\dat$)):bs=bs+4
							Case 3 WriteFloat(udp,Float(udp_data\dat$)):bs=bs+4
							Case 4 WriteLine(udp,udp_data\dat$):bs=bs+10
						End Select
					EndIf
				Next
				;Imp-ID schreiben, Paket senden und Zeitpunkt des Sendens abspeichern
				WriteShort (udp,udp_data_h\id)
				SendUDPMsg(udp, udp_data_h\targetip, udp_data_h\targetport)
				udp_sendb(bs+2)
				udp_data_h\sended=ms
								
				;Beim erreichen der Maxfails den Sendevorgang abbrechen
				udp_data_h\fails=udp_data_h\fails+1
				If udp_data_h\maxfails<>0 Then
					If udp_data_h\fails>udp_data_h\maxfails Then udp_freeimp(udp_data_h\id)
				EndIf
			EndIf
		Next
		;Alte Blocker lschen
		For udp_getblock.udp_getblock=Each udp_getblock
			If ms-udp_getblock\got>udp_blockdel Then
				Delete udp_getblock
			EndIf
		Next
	EndIf
End Function

;--------------------Ok imp Send
Function udp_okimpsend(id,ip,port)
	WriteByte(udp,255)
	WriteShort(udp,id)
	SendUDPMsg(udp,ip,port)
	udp_sendb(3)
	;Getblock vorhanden? -> 0
	For udp_getblock.udp_getblock=Each udp_getblock
		If udp_getblock\sourceip=ip Then
			If udp_getblock\sourceport=port Then
				If udp_getblock\id=id Then
					udp_getblock\got=ms
					Return 0
				EndIf
			EndIf
		EndIf
	Next
	;Kein Block vorhanden? -> 1
	udp_getblock.udp_getblock=New udp_getblock
	udp_getblock\id=id
	udp_getblock\sourceip=ip
	udp_getblock\sourceport=port
	udp_getblock\got=ms
	Return 1
End Function




;--------------------Send Imp Byte
Function udp_w_byte(value)
	WriteByte(udp,value)
	udp_data.udp_data=New udp_data
	udp_data\id=udp_imp
	udp_data\typ=0
	udp_data\dat$=value
End Function

;--------------------Send Imp Short
Function udp_w_short(value)
	WriteShort(udp,value)
	udp_data.udp_data=New udp_data
	udp_data\id=udp_imp
	udp_data\typ=1
	udp_data\dat$=value
End Function

;--------------------Send Imp Int
Function udp_w_int(value)
	WriteInt(udp,value)
	udp_data.udp_data=New udp_data
	udp_data\id=udp_imp
	udp_data\typ=2
	udp_data\dat$=value
End Function

;--------------------Send Imp Float
Function udp_w_float(value#)
	WriteFloat(udp,value#)
	udp_data.udp_data=New udp_data
	udp_data\id=udp_imp
	udp_data\typ=3
	udp_data\dat$=value#
End Function

;--------------------Send Imp Line
Function udp_w_line(value$)
	WriteLine(udp,value$)
	udp_data.udp_data=New udp_data
	udp_data\id=udp_imp
	udp_data\typ=4
	udp_data\dat$=value$
End Function


;--------------------Send Bytes adden
Function udp_sendb(bytes)
	e_sendbytes_f=e_sendbytes_f+8+bytes
End Function


;--------------------UDP Local
Function udp_local()
	If udp_local=0 Then udp_local=CreateUDPStream()
	If udp_local=0 Then con_add("Warning: Failed to open local udp port!",0,1)
End Function

;--------------------UDP Local Message
Function udp_lmsg(id,msg$)
	WriteByte udp_local,id
	WriteLine udp_local,msg$
	SendUDPMsg(udp_local,udp_local_destip,udp_local_destport)
End Function